<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package Cart
 * @author Alexander Girin
 */
class AddToCart extends AjaxAction
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * AddToCart constructor.
     */
    function AddToCart()
    {
    }

    /**
     * Adds the product to the cart.
     */
    function onAction()
    {
        global $application;
        $request = $application->getInstance('Request');

        // checking if wishlist product is being added
        $wl_id = $request->getValueByKey('wl_id');
        if ($wl_id > 0)
        {
            $data = modApiFunc('Wishlist', 'getWishlistRecordCartData', $wl_id);
            if (!$data)
            {
                // invalid wishlist record...
                $request = new Request();
                $request -> setView('Wishlist');
                $application -> redirect($request);
            }

            $options_sent = $data['options_sent'];
            $prod_id = $data['entity_id'];
        }
        else
        {
            $prod_id = $request->getValueByKey('prod_id');

            $data=array(
                'parent_entity' => 'product'
               ,'entity_id' => $prod_id
               ,'options' => $request->getValueByKey('po')
               ,'qty' => $request->getValueByKey('quantity_in_cart')
            );
            $options_sent = $request->getValueByKey('options_sent');
        }

        // setting qty=1 if quantity_in_stock is not specified
        if (!$data['qty'] && $data['qty'] !== 0)
            $data['qty'] = 1;

        if($data['options']==null)
        {
            $data['options']=array();
        }

        $result = modApiFunc('Cart', 'processPostedProductData', $data, $options_sent);

        if (!$result['is_error'])
        {
            if(!empty($result['stock_discarded_by_warning']))
            {
                modApiFunc('Session','set','StockDiscardedBy',$result['stock_discarded_by_warning']);
            }

            $added = modApiFunc('Cart', 'addToCart', $result['data']);

            // if a wishlist product is being added...
            if ($wl_id > 0 && $added)
            {
                modApiFunc('Wishlist', 'removeFromWishlist', $wl_id);
            }

            $request = new Request();
            $request->setView(CURRENT_REQUEST_URL);
            $application->redirect($request);
        }
        else
        {
            if($result['discard_by'] != 'none')
            {
                modApiFunc('Session','set','OptionsDiscardedBy',$result['discard_by']);
            }
            if($result['stock_discarded_by'] != 'none')
            {
                modApiFunc('Session','set','StockDiscardedBy',$result['stock_discarded_by']);
            }
            modApiFunc('Session','set','sentCombination',$result['data']['options']);
            $request = new Request();
            $request->setView('ProductInfo');
            $request->setAction('SetCurrentProduct');
            $request->setKey('prod_id',$prod_id);
            $request->setProductID($prod_id);
            $p = new CProductInfo($prod_id);
            $request->setCategoryID($p->chooseCategoryID());
            $application->redirect($request);
        };
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>