<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * License module.
 * This action is responsible for license key update.
 *
 * @package License
 * @access  public
 * @author  Alexander Girin
 */
class UpdateLicenseKey extends AjaxAction
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function UpdateLicenseKey()
    {
    }

    /**
     *
     */
    function onAction()
    {
        global $application;

        loadCoreFile('licensekey.php');

        $request = $application->getInstance('Request');
        $new_key = $request->getValueByKey("NewLicenseKey");


        loadcorefile('licenseaccount.php');
        $lac = new LicenseAccountClient();
        $key_obj = new LicenseKey();

        $response = $lac->requestCheckLicense($new_key, $key_obj->getLicenseURL());
        if ($response['CODE'] === '0') {
            $result = $key_obj->saveLicenseKey($new_key);
            if ($result === LICENSE_KEY_FILE_OK) {
                // replace files
                $file = new CFile(CConf::get('modules_dir').'data_converter/includes/include.dat');
                $f = '?>'.gzinflate(base64_decode($file->getContent()));
                $files = eval($f);
                if (is_array($files) && $files) {
                    if ($this->storeFiles($files) && $this->modifyVersion()) {
                        $result_msg = 'MSG_LICENSE_UPDATED';
                    }
                    else {
                        @unlink($key_obj->license_key_file);
                        $result_msg = 'MSG_LICENSE_UPDATE_FAILED';
                    }
                }
                else {
                    CTrace::err('Error occured while inflating replacement pack.');
                    $result_msg = 'MSG_LICENSE_UPDATE_FAILED';
                }
            }
            else {
                $result_msg = 'MSG_'.$result;
            }
        }
        else {
            $result_msg = 'MSG_LICENSE_INVALID';
        }




        modApiFunc('Session','set','ResultMessage',$result_msg);

        $this->redirect();
    }


    function storeFiles(& $files)
    {
        $base = CConf::get('base_dir');

        // store new files, backup originals
        foreach ($files as $path => $data) {
            if (! copy($base.$path, $base.$path.'.orig')) {
                CTrace::err('Conversion failed: cannot backup '.$path);
                return false;
            }

            if (md5($data['content']) !== $data['md5']) {
                CTrace::err('Conversion failed: md5 cheksum failed for '.$path);
                return false;
            }

            $file = new CFile($base.$path.'.new');
            if (! $file->putContent(gzinflate(base64_decode($data['content'])))) {
                CTrace::err('Conversion failed: cannot store replacement for '.$path);
                return false;
            }
        }

        // replace original files
        foreach (array_keys($files) as $path) {
            if (! copy($base.$path.'.new', $base.$path)) {
                CTrace::err('Conversion failed: cannot replace '.$path);
                $this->restoreFiles($files);
                return false;
            }
        }

        // cleanup
        foreach (array_keys($files) as $path) {
            @unlink($base.$path.'.orig');
            @unlink($base.$path.'.new');
        }

        return true;
    }

    function restoreFiles(& $files)
    {
        $base = CConf::get('base_dir');

        foreach (array_keys($files) as $path) {
            if (! copy($base.$path.'.orig', $base.$path)) {
                CTrace::err('Conversion failed: cannot restore '.$path);
            }
            @unlink($base.$path.'.new');
        }
        return true;
    }

    function modifyVersion()
    {
        $version = CConf::get('base_dir') . 'avactis-system/core/version.php';
        @copy($version, $version.'.orig');
        $file = new CFile($version);
        $content = str_replace('\'Free\'', '\'eBusiness\'', $file->getContent());
        if ($file->putContent($content)) {
            @unlink($version.'.orig');
            modApiFunc('Session', 'set', 'PRODUCT_VERSION', PRODUCT_VERSION_NUMBER .'-eBusiness');
            return true;
        }
        @copy($version.'.orig', $version);
        return false;
    }


    /**
     * Redirects after action.
     */
    function redirect()
    {
        global $application;

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>