<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update 2Checkout settings.
 *
 * @package PaymentModule2CheckoutCC
 * @access  public
 * @author Egor Makarov
 */
class update_2checkout extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor
     */
    function update_2checkout()
    {
    }


    function isValidId($id_str)
    {
        /*
        if (empty($id_str)) return false;
        if (_ml_strlen($id_str) <> 6) return false;
        $val = preg_match_all("([0-9]{6})", $id_str, $regs);
        return $val == 6;
        */
        return true;
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_2Checkout_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array
            (
                "MODULE_NAME"  => $SessionPost["ModuleName"]
//              ,"MODULE_DESCR" => $SessionPost["ModuleDescr"]
                ,"MODULE_ID" => $SessionPost["ModuleId"]
                ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                ,"MODULE_CHECKOUT" => $SessionPost["ModuleCheckout"]
            );

        if (array_key_exists("ModuleUseSecret", $SessionPost))
        {
            $Settings["MODULE_USE_SECRET"] = "1";
            $Settings["MODULE_SECRET"] = $SessionPost["ModuleSecret"];
        }
        else
        {
            $Settings["MODULE_USE_SECRET"] = "0";
        }
        modApiFunc("Payment_Module_2Checkout_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                //$nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (empty($SessionPost["ModuleName"]) == true || trim($SessionPost["ModuleName"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }

                $supportedCurrencies = array("AUD", "CAD", "CHF", "DKK", "EUR", "GBP",
                    "HKD", "JPY", "NOK", "NZD", "SEK", "USD");

                $main_currency_id = modApiFunc("Localization", "getMainStoreCurrency");
                $localCurrencyCode = modApiFunc("Localization", "getCurrencyCodeById", $main_currency_id);

                if ($SessionPost["status"] == "active")
                {
                if (empty($SessionPost["ModuleId"]) == true || $this->isValidId(trim($SessionPost["ModuleId"])) == false)
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_ID";
                }
                if (array_key_exists("ModuleUseSecret", $SessionPost) == true && (empty($SessionPost["ModuleSecret"]) == true || trim($SessionPost["ModuleName"]) == ''))
                {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_SECRET";
                }
                    if (in_array($localCurrencyCode, $supportedCurrencies) === false)
                    {
                    	$SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_INVALID_CURRENCY";
                    }
                }


                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>