<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * 2checkout_cc_input_az view.
 *
 * @package PaymentModule2CheckoutCC
 * @author Egor Makarov
 */
class CheckoutPaymentModule2CheckoutCCInputAZ extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function CheckoutPaymentModule2CheckoutCCInputAZ()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-2checkout-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     *Initializes data from the POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
    }

    /**
     * Initializes data from the database.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_2Checkout_CC", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":     $this->POST["ModuleName"] = $value; break;
                case "MODULE_ID":       $this->POST["ModuleId"] = $value; break;     // id
                case "MODULE_USE_SECRET": //                 SecretWord
                    if ($value == "1")
                    {
                        $this->POST["ModuleUseSecret"] = "";
                    }
                    break;
                case "MODULE_SECRET":   $this->POST["ModuleSecret"] = $value; break; // secret word (                                     )
                case "MODULE_MODE":     $this->POST["ModuleMode"] = $value; break;
                case "MODULE_CHECKOUT": $this->POST["ModuleCheckout"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Payment_Module_2Checkout_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * Outputs errors.
     */
    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_2checkout/", "error.tpl.html", array());
        }
        return $result;
    }

    /**
     * Outputs the module status.
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked" : ""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "" : "checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_2checkout/", "status.tpl.html", array());
        return $retval;
    }

    /**
     *
     */
    function outputOrderStatus()
    {
        global $application;
        $retval = "";
        for ($i=1; $i<5; $i++)
        {
            $retval.= "<option value=\"$i\" ";
            $retval.= ($this->POST["ModuleOrderStatusId"] == $i)? ' selected="selected" ' : "";
            $retval.= ">" . $this->MessageResources->getMessage('MODULE_ORDER_STATUS_00'.$i) . "</option>";
        }
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_2checkout/", "status.tpl.html", array());
        return $retval;
    }

    function outputModeOptions()
    {
        $retval = "";
        $options = array(array("value" => "1", "text" => $this->MessageResources->getMessage('MODE_001')), array("value" => "2", "text" => $this->MessageResources->getMessage('MODE_002')));
        foreach ($options as $option)
        {
            $retval.= "<option value='".$option["value"]."' ".($option["value"]==$this->POST["ModuleMode"]? 'selected="selected"':"").">".$option["text"]."</option>";
        }
        return $retval;
    }

    function outputCheckoutVariants()
    {
        $retval = '';
        $variant = $this->POST['ModuleCheckout'];
        $mode1 = $this->MessageResources->getMessage('MODE_COMMON');
        $mode2 = $this->MessageResources->getMessage('MODE_ONE_STEP');

        $selected1 = "checked='CHECKED'";
        $selected2 = "";
        if ($variant != "COMMON")
        {
            $selected2 = "checked='CHECKED'";
            $selected1 = "";
        }

        $retval = "<label><input name='ModuleCheckout' type='radio' value='COMMON' $selected1>$mode1</label><br /><label><input name='ModuleCheckout' type='radio' value='ONE_STEP' $selected2>$mode2</label>";

        return $retval;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_2checkout");
        $form_action = $request->getURL();

        $template_contents = array(
                                    "Edit2CheckoutForm"        => $HtmlForm1->genForm($form_action, "POST", "Edit2CheckoutForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()

                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusFieldHint" => $this->Hints->getHintLink(array('MODULE_STATUS_FIELD_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleStatusField"     => $this->outputStatus()

                                   ,"ModuleMethodNameFieldName"   => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME')
                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))

                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                                   ,"ModuleDescrFieldHint"  => $this->Hints->getHintLink(array('MODULE_DESCR_FIELD_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleDescrField"      => $HtmlForm1->genInputTextAreaField("75", "ModuleDescr", "5")
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage("MODULE_DESCR")

                                   ,"ModuleIdFieldName"  => $this->MessageResources->getMessage('MODULE_ID_FIELD_NAME')
                                   ,"ModuleIdFieldHint"  => $this->Hints->getHintLink(array('MODULE_ID_FIELD_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleIdField"      => $HtmlForm1->genInputTextField("128", "ModuleId", "30", prepareHTMLDisplay($this->POST["ModuleId"]))

                                   ,"ModuleCheckoutFieldHint"  => $this->Hints->getHintLink(array('MODULE_CHECKOUT_FIELD_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleCheckoutField"      => $this->outputCheckoutVariants()

                                   //,"ModuleUseSecretFieldName" => $this->MessageResources->getMessage('MODULE_USE_SECRET_NAME')
                                   //,"ModuleUseSecretFieldHint" => $this->Hints->getHintLink(array('MODULE_USE_SECRET_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleUseSecretField"     => $this->genInputCheckBox("ModuleUseSecret", array_key_exists("ModuleUseSecret", $this->POST), $this->MessageResources->getMessage("MODULE_USE_SECRET_TEXT"))

                                   ,"ModuleSecretFieldName"  => $this->MessageResources->getMessage('MODULE_SECRET_FIELD_NAME')
                                   ,"ModuleSecretFieldHint"  => $this->Hints->getHintLink(array('MODULE_SECRET_FIELD_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleSecretField"      => $HtmlForm1->genInputTextField("128", "ModuleSecret", "30", prepareHTMLDisplay(isset($this->POST["ModuleSecret"])?$this->POST["ModuleSecret"]:''))

                                   ,"ModuleModeFieldName"    => $this->MessageResources->getMessage('MODULE_MODE_FIELD_NAME')
                                   ,"ModuleModeFieldHint"    => $this->Hints->getHintLink(array('MODULE_MODE_FIELD_NAME', 'payment-module-2checkout-messages'))
                                   ,"ModuleModeOptions"      => $this->outputModeOptions()

                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   //,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   //,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')

                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()
                                  );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_2checkout/", "list.tpl.html", array());
    }

    /**
     *
     */
    function genInputCheckBox($name, $checked, $text)
    {
        $retval = "name=\"{$name}\" " . ($checked ? " checked " : "") . " value=\"{$text}\"";
        return $retval;
    }

    /**
     * Returns the tag output, whose name is specified in $tag.
     */
    function getTag($tag)
    {
        global $application;
        $value = "";

        if ($tag == "Error")
        {
            $value = $this->_error;
        }
        elseif ($tag == "ErrorIndex")
        {
                $value = $this->_error_index;
        }
        else
        {
            $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        }

        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It  omes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/

}
?>