<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleCamtechCC
 * @author Sergey Kulitsky
 *
 */

class CheckoutPaymentModuleCamtechCCOutput
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     *                                                     .
     */
    function getTemplateFormat()
    {
        $format = array(
            'layout-file' =>
                'checkout-payment-module-camtech-cc-output-config.ini',
            'files' => array(
                'OutputContainer' => TEMPLATE_FILE_SIMPLE
            ),
            'options' => array()
        );
        return $format;
    }

    /**
     *  CheckoutPaymentModuleCamtechCCOutput constructor
     */
    function CheckoutPaymentModuleCamtechCCOutput()
    {
        global $application;

        //
        $this -> NoView = false;
        if ($application -> issetBlockTagFatalErrors(
                $this -> BlockTemplateName
           ))
            $this -> NoView = true;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        $msg = & $application -> getInstance('MessageResources');

        $this -> templateFiller = & $application -> getInstance(
                                                        'TemplateFiller'
                                                    );
        $this -> template = $application -> getBlockTemplate(
                                                $this->BlockTemplateName
                                            );
        $this -> templateFiller -> setTemplate($this -> template);

        $this -> _Template_Contents = array(
            'Local_PaymentMethodName' => '',
            'Local_CreditCardInfoOutput' => ''
        );

        $application -> registerAttributes($this -> _Template_Contents);
        $retval = $this -> templateFiller -> fill('OutputContainer');
        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        $ModuleInfo = modApiFunc($this -> ModuleAPIClassName, 'getInfo');
        $settings = modApiFunc($this -> ModuleAPIClassName, 'getSettings');

        switch ($tag)
        {
            case 'Local_PaymentMethodName':
                $value = $settings['MODULE_NAME'];
                break;

            case 'Local_CreditCardInfoOutput':
                $pm_uuid = modApiFunc($this->ModuleAPIClassName, 'getUid');
                $value = getCheckoutCreditCardInfoOutput($pm_uuid);
                break;
        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $ModuleAPIClassName = 'Payment_Module_Camtech_CC';
    var $BlockTemplateName = 'CheckoutPaymentModuleCamtechCCOutput';
    /**#@-*/

}
?>