<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update epay settings.
 *
 * @package PaymentModuleepay CC
 * @access  public
 * @author Yapharov Leonid
 */
class update_EPAY extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_EPAY()
    {
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_EPAY_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"  => $SessionPost["ModuleName"]
                         ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                         ,"MODULE_LANGUAGE" => $SessionPost["ModuleLanguage"]
                         ,"MODULE_MERCHANT_NUMBER" => $SessionPost["ModuleMerchantNumber"]
                         ,"MODULE_CPI_URL" => $SessionPost["ModuleCpiUrl"]
                         );
        modApiFunc("Payment_Module_EPAY_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                $nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if(empty($SessionPost["ModuleName"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleName"] = new ActionMessage(array("ALERT_001_PHP"));
                }
                if(empty($SessionPost["ModuleMerchantNumber"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleMerchantNumber"] = new ActionMessage(array("ALERT_002_PHP"));
                }
                if(empty($SessionPost["ModuleCpiUrl"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleCpiUrl"] = new ActionMessage(array("ALERT_004_PHP"));
                }
                else
                {
                    // url validation
                    //
                    $urlString = $SessionPost["ModuleCpiUrl"];
                    loadCoreFile("URI.class.php");
                    $url = new URI($urlString);
                    if ($url == NULL)
                    {
                        $SessionPost["ViewState"]["ErrorsArray"]["ModuleCpiUrl"] = new ActionMessage(array("ALERT_005_PHP"));
                    }
                    else if ($url->getPart("scheme") == NULL ||
                        $url->getPart("host") == NULL ||
                        $url->getPart("user") != NULL ||
                        $url->getPart("pass") != NULL ||
                        $url->getPart("query") != NULL )
                    {
                        $SessionPost["ViewState"]["ErrorsArray"]["ModuleCpiUrl"] = new ActionMessage(array("ALERT_005_PHP"));
                    }
                }
                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>