<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleepayCC
 * @author Yapharov Leonid
 */
class Payment_Module_epay_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * PaymentModuleepay  constructor.
     */
    function Payment_Module_epay_CC()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-epay-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_MODULE_ID') . $info["GlobalUniquePaymentModuleID"] . "\n" .
        $this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_MODULE_NAME') . $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;

        list($usec, $sec) = explode(" ",microtime());

        return $this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_EVENT_TIME') . (float)($usec + $sec);
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_EPAY_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $MessageResources = &$application->getInstance('MessageResources',"payment-module-epay-messages", "AdminZone");

        $tables = Payment_Module_epay_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_epay_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($MessageResources->getMessage('MODULE_NAME')).':"'.$MessageResources->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_NUMBER", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_CPI_URL", $columns['key']);
        $query->addInsertValue('s:57:"https://ssl.ditonlinebetalingssystem.dk/popup/default.asp";', $columns['value']);
        $application->db->getDB_Result($query);


        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_LANGUAGE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_epay_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_epay_CC                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-epay-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * Returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "5C6A3A71-9703-D0A7-F8BD-A22E8317D664";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')."</span>":$this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "epay_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleEPAYCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleEPAYCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_epay_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settins array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_epay_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settins array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_epay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_epay_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_epay_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_epay_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;

        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);

        switch ($currency)
        {
            case "DKK":
                $currency = 208;
                break;
            case "EUR":
                $currency = 978;
                break;
            case "USD":
                $currency = 840;
                break;
            case "NOK":
                $currency = 578;
                break;
            case "SEK":
                $currency = 752;
                break;
            case "GBP":
                $currency = 826;
                break;
            default:
                $currency = 208;//DKK
                break;
        }


        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currency_id);

        $billingInfo = new ArrayAccessLayer($orderInfo);
        $billingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer($orderInfo);
        $shippingInfo->setAccessMask("Shipping", "attr", AAL_CUSTOM_PARAM, "value");

        $billingCounty = modApiFunc("Location", "getStateCodeByStateName", $billingInfo->getByMask('State'));
        if (!$billingCounty)
        {
            $billingCounty = $billingInfo->getByMask('State');
        }

        $shippingCounty = modApiFunc("Location", "getStateCodeByStateName", $shippingInfo->getByMask('State'));
        if (!$shippingCounty)
        {
            $shippingCounty = $shippingInfo->getByMask('State');
        }

        $this->getSettings();
        $confirmationData = array
        (
                "FormAction" => $this->Settings['MODULE_CPI_URL']
               ,"FormMethod" => "POST"
               ,"DataFields" => array
                    (
                       "merchantnumber" => $this->Settings['MODULE_MODE']== 1? "99999999":$this->Settings['MODULE_MERCHANT_NUMBER']
                       ,"amount" => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id)), 2, '.', '')
                       ,"currency" => $currency
                       ,"orderid" => $orderId
                       ,"description" => modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_NAME)
                       ,"group" => ""
                       ,"ordertext" => ""
                       ,"language" => $this->Settings['MODULE_LANGUAGE']
                       ,"accepturl" => $self_link ."&status=accept"
                       ,"declineurl" => $self_link ."&status=declined"
                       ,"callbackurl" => ""
                       ,"instantcapture" => ""
                       ,"md5key" => ""
                       ,"authsms" => ""
                       ,"authmail" => ""
                       ,"cardtype" => ""
                       ,"windowstate" => "1"
                       ,"use3D" => ""
                       ,"http_cookie" => getenv("HTTP_COOCKIE")
//                       ,"addfee" =>  ($this->Settings['MODULE_MODE']-1)
                       ,"subscription" => ""
                       ,"BillingAddress1" => $billingInfo->getByMask('Streetline1')
                       ,"BillingAddress2" => $billingInfo->getByMask('Streetline2')
                       ,"BillingCity" => $billingInfo->getByMask('City')
                       ,"BillingCountry" => modApiFunc("Location", "getCountryCodeByCountryName", $billingInfo->getByMask('Country'))
                       ,"BillingCounty" => $billingCounty
                       ,"BillingFirstName" => $billingInfo->getByMask('Firstname')
                       ,"BillingLastName" => $billingInfo->getByMask('Lastname')
                       ,"BillingPostal" => $billingInfo->getByMask('Postcode')
                       ,"ShopperEmail" => modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_EMAIL)
                       ,"ShippingAddress1" => $shippingInfo->getByMask('Streetline1')
                       ,"ShippingAddress2" => $shippingInfo->getByMask('Streetline2')
                       ,"ShippingCity" => $shippingInfo->getByMask('City')
                       ,"ShippingCountry" => modApiFunc("Location", "getCountryCodeByCountryName", $shippingInfo->getByMask('Country'))
                       ,"ShippingCounty" => $shippingCounty
                       ,"ShippingFirstName" => $shippingInfo->getByMask('Firstname')
                       ,"ShippingLastName" => $shippingInfo->getByMask('Lastname')
                       ,"ShippingPostal" => $shippingInfo->getByMask('Postcode')
                    )
            );

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function getErrorMessage($code)
    {
        switch ($code)
        {
            case -1: return $this->MessageResources->getMessage('ERROR_COMMUNICATION_FAILURE_RETURN_MSG');
            case -2: return $this->MessageResources->getMessage('ERROR_COMMUNICATION_FAILURE_RETURN_MSG');
            case -3: return $this->MessageResources->getMessage('ERROR_COMMUNICATION_FAILURE_RETURN_MSG');
            case -4: return $this->MessageResources->getMessage('ERROR_COMMUNICATION_FAILURE_RETURN_MSG');
            case -1000: return $this->MessageResources->getMessage('ERROR_COMMUNICATION_FAILURE_RETURN_MSG');
            case -1001: return $this->MessageResources->getMessage('ERROR_ORDERNUMBER_EXISTS_RETURN_MSG');
            case -1100: return $this->MessageResources->getMessage('ERROR_UNKNOWN_RETURN_MSG');
            case -1200: return $this->MessageResources->getMessage('ERROR_UNKNOWN_CURRENCY_RETURN_MSG');
            case -1300: return $this->MessageResources->getMessage('ERROR_CARDNO_NOT_VALID_RETURN_MSG');
            case 101: return $this->MessageResources->getMessage('ERROR_CARD_EXPIRED_RETURN_MSG');
            case 111: return $this->MessageResources->getMessage('ERROR_CARDNO_NOT_VALID_RETURN_MSG');
            case 123: return $this->MessageResources->getMessage('ERROR_CVC_NOT_VALID_RETURN_MSG');
            case 106: return $this->MessageResources->getMessage('ERROR_TRANSACTION_DECLINED_RETURN_MSG');
            case 110: return $this->MessageResources->getMessage('ERROR_WRONG_NUMBER_FORMAT_RETURN_MSG');
            case 116: return $this->MessageResources->getMessage('ERROR_NO_FUNDS_RETURN_MSG');
            default: return $this->MessageResources->getMessage('ERROR_TRANSACTION_DECLINED_RETURN_MSG').'('.$code.')';
        }
        return $this->MessageResources->getMessage('ERROR_TRANSACTION_DECLINED_RETURN_MSG');
    }

    function getBodyOnLoad()
    {
        $script = "var iWinState = 1; ";
        $script.= "var objForm = null; ";
        $script.= "var winl = (screen.width - 525) / 2;";
        $script.= "var wint = (screen.height - 600) / 2;";
        $script.= "if(document.checkout) objForm = document.checkout; ";
        $script.= "else objForm = document.getElementById('checkout'); ";
        $script.= "if(objForm.windowstate) iWinState = objForm.windowstate.value; ";
        $script.= "if (iWinState == '1'){ ";
        $script.= "var epaywin = window.open('','ePay_window','height=600,width=525,menubar=0,resizable=1,scrollbars=1,status=1,titlebar=0,toolbar=0,left='+winl+',top='+wint); ";
        $script.= "if (epaywin) epaywin.focus(); ";
        $script.= "objForm.target = 'ePay_window'; } ";
        $script.= "else objForm.target = ''; ";
        $script.= "objForm.submit(); ";
        return $script;
    }

    function processData($data, $order_id)
    {
        //the first step of data processing from the Payment Gateway
        //the payment status update.
        //the next step.
        //do not call the Payment Gateway.
        $DBPaymentStatus = array();
        $order_status = isset($data["_GET"]["status"])? $data["_GET"]["status"]:"";
        $tid = isset($data["_GET"]["tid"])? $data["_GET"]["tid"]:"";
        $orderid = isset($data["_GET"]["orderid"])? $data["_GET"]["orderid"]:"";
        $amount = isset($data["_GET"]["amount"])? $data["_GET"]["amount"]:"";
        $cur = isset($data["_GET"]["cur"])? $data["_GET"]["cur"]:"";
        $date = isset($data["_GET"]["date"])? $data["_GET"]["date"]:"";
        $error_code = isset($data["_GET"]["error"])? $data["_GET"]["error"]:"";

//        if (intval($error_code)!=116)
//        {
//            $order_status="declined";
//        }

        switch ($order_status)
        {
            case "accept":
                $EventType = "ConfirmationSuccess";
                modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $tid);
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_EVENT_DESCRIPTION'). $this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_TRANSACTION_ACCEPTED')."\n".$this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_GET_DATA') . "\n" . print_r($data["_GET"], true));
                break;
                break;
            case "declined":
                $EventType = "ConfirmationFailure";
                $error_message=$this->getErrorMessage($error_code);
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_EVENT_DESCRIPTION').$error_message."\n".$this->MessageResources->getMessage('MODULE_PAYMENT_EPAY_LOG_POST_DATA') . "\n" . print_r($data["_GET"], true));
                break;
        }
        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_epay_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_epay_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_epay_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_epay_setting_id'
               ,'key'               => $settings.'.pm_epay_setting_key'
               ,'value'             => $settings.'.pm_epay_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>