<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleIDEALCC
 * @author Egor V. Derevyankin
 *
 */

class update_ideal extends update_pm_sm
{
    function update_ideal()
    {}

    function onAction()
    {
        global $application;
        $request = new Request();
        $status = $request->getValueByKey('status');
        $sets = $request->getValueByKey('sets');

        $errors = array();

        $req_errors = modApiFunc('Payment_Module_IDEAL_CC','checkRequirments');
        if(!empty($req_errors) and $status == 'active')
        {
            $errors = $req_errors;
            $status = 'inactive';
        };

        if($sets['MODULE_NAME'] == '')
        {
            $errors[] = 'ERROR_NO_MODULE_NAME';
        };
        if($sets['MERCHANT_ID'] == '')
        {
            $errors[] = 'ERROR_NO_MERCHANT_ID';
        };
        if($sets['SUB_ID'] == '')
        {
            $errors[] = 'ERROR_NO_SUB_ID';
        };

        if(!in_array($sets['TRNS_MODE'],array(PM_IDEAL_TRNS_MODE_TEST, PM_IDEAL_TRNS_MODE_PRODUCTION)))
        {
            $sets['TRNS_MODE'] = PM_IDEAL_TRNS_MODE_TEST;
        };


        if(empty($errors))
        {
            if(!modApiFunc('Payment_Module_IDEAL_CC','areCurrentKeysCorrect'))
            {
                $status = 'inactive';
            };

            modApiFunc('Checkout', 'setModuleActive',
                modApiFunc('Payment_Module_IDEAL_CC', 'getUid'),
                ($status == "active"));

            modApiFunc('Payment_Module_IDEAL_CC','updateSettings',$sets);
            $SessionPost = array(
                'ViewState' => array(
                    'hasCloseScript' => 'true'
                )
            );
        }
        else
        {
            modApiFunc('Checkout', 'setModuleActive',
                modApiFunc('Payment_Module_IDEAL_CC', 'getUid'),false);

            $SessionPost = array(
                'ViewState' => array(
                    'ErrorsArray' => $errors
                   ,'hasCloseScript' => 'false'
                   ,'FormSubmitValue' => ''
                  )
               ,'sets' => $sets
               ,'status' => false
            );
        };

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
};

?>