<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleInnovativeCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Innovative_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )

            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }
    /**
     * PaymentModuleInnovative  constructor.
     */
    function Payment_Module_Innovative_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'InnovativeErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'InnovativeErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'InnovativeErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'InnovativeErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'InnovativeErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_INNOVATIVE_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_INNOVATIVE_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Innovative_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");

        $tables = Payment_Module_Innovative_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_innovative_settings';                #the name of the filled table
        $columns = $tables[$table]['columns'];      #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_USERNAME", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Innovative_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Innovative UID
//        return "CA60BCBF-2879-4DE6-B6FF-D7544DF48E01";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "innovative_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleInnovativeCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleInnovativeCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_innovative_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_innovative_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_innovative_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_innovative_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_innovative_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_innovative_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        return;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $mres = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");

        //
        // The checking on the delivery to the selected place might be
        // added here
        //
        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $mres->getMessage('MODULE_PAYMENT_INNOVATIVE_LOG_EVENT_DESCRIPTION') . "\n" . $mres->getMessage('MODULE_PAYMENT_INNOVATIVE_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);

        if (isset($data["_POST"]["approved"])
            || isset($data["_POST"]["test_override_errors"]))
        {
	        $EventType = "ConfirmationSuccess";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);

            if (isset($data["_POST"]["avs"]))
            {
                $msg = $mres->getMessage("AVS_RESPONSE") . $data["_POST"]["avs"];
                $msg .= "\n" . $mres->getMessage("AVS_RESPONSE_" . $data["_POST"]["avs"]);
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }
            else
            {
                $msg = $mres->getMessage("AVS_NO_RESPONSE");
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }

            if (isset($data["_POST"]["cvv2_result"]))
            {
                $msg = $mres->getMessage("CCV_RESPONSE") . $data["_POST"]["cvv2_result"];
                $msg .= "\n" . $mres->getMessage("CCV_RESPONSE_" . $data["_POST"]["cvv2_result"]);
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }
            else
            {
                $msg = $mres->getMessage("CCV_NO_RESPONSE");
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }
       	}
       	else
       	{
	        $EventType = "ConfirmationFailure";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
       	}
	    return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Innovative_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Innovative_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $sstate =    $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext');
        $scountry =  $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country');

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        $settings = $this->getSettings();

        $cardNumber = isset($CCInfo["CreditCardNumber"]["value"])
            ? $CCInfo["CreditCardNumber"]["value"] : "";
        $CVM = isset($CCInfo["CreditCardVerificationNumber"]["value"])
            ? $CCInfo["CreditCardVerificationNumber"]["value"] : "";

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? $CCInfo["ExpirationYear"]["value"] : "";
        $cardType = isset($CCInfo["CreditCardType"]["value"])
            ? $CCInfo["CreditCardType"]["value"] : "";

        $cardTypeNotAllowable = false;
        $allowableTypes = array(
                "Visa" => "visa",
                "VisaD" => "visa",
                "VisaE" => "visa",
                "MasterCard" => "mc",
                "Amex" => "amex",
                "DC" => "diners",
                "Discover" => "discover",
                "JCB" => "jcb"
        );

        if (isset($allowableTypes[$cardType]))
        {
            $cardType = $allowableTypes[$cardType];

            $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
            $main_currency_code = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
            $total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId));

        // convert total to USD, if necessary
            if ($main_currency_code != "USD")
            {
                if(modApiFunc('Currency_Converter', 'isConvertAvail', $main_currency_code, "USD"))
                {
                    $newCartTotal = modApiFunc('Currency_Converter', 'convert', $total, $main_currency_code, "USD");

//                    if($this->is_debug == true)
//                    {
//                        $msg = $this->MessageResources->getMessage('LABEL_CONVERTING');
//                        $this->_debug_info[] = array($msg, "{$main_currency_code} -> CAD: {$total} -> {$newCartTotal}");
//                    }

                    $total = $newCartTotal;
                }
            }
            $total = number_format($total, 2, '.', '');

            // uncomment for testing
//            $transaction["test_override_errors"] = true;

            $transaction["target_app"] = "WebCharge_v5.06";
            $transaction["response_mode"] = "simple";
            $transaction["response_fmt"] = "delimited";
            $transaction["upg_auth"] = "zxcvlkjh";
            $transaction["delimited_fmt_field_delimiter"] = "=";
            $transaction["delimited_fmt_include_fields"] = "true";

            $transaction["delimited_fmt_value_delimiter"] = "|";

            // Your Gateway Authorization Credentials:                  // test values:
            $transaction["username"] = $settings["MODULE_USERNAME"];    // gatewaytest
            $transaction["pw"] = $settings["MODULE_PASSWORD"];          // GateTest2002

            $transaction["trantype"] = "sale";
            $transaction["reference"] = "";
            $transaction["trans_id"] = "";
            $transaction["authamount"] = "";
            $transaction["cardtype"] = $cardType;
            // Allowable Card Types:
            //      visa, mc, amex, diners, discover, jcb

        // Credit Card information
            $transaction["ccnumber"] = $cardNumber;
            $transaction["ccidentifier1"] = $CVM;
        // CC# may include spaces or dashes.

            $transaction["month"] = $cardExpMonth; // Must be TWO DIGIT month.
            $transaction["year"] =  $cardExpYear; // Must be TWO or FOUR DIGIT year.

            $transaction["fulltotal"] = $total; // Total amount WITHOUT dollar sign.

            $transaction["ccname"] = $billingInfo->getByMask('Firstname') . ' ' . $billingInfo->getByMask('Lastname');
            $transaction["baddress"] = $billingInfo->getByMask('Streetline1');
            $transaction["baddress1"] = $billingInfo->getByMask('Streetline2');
            $transaction["bcity"] = $billingInfo->getByMask('City');
            $transaction["bstate"] = $bstate;
            $transaction["bzip"] = $billingInfo->getByMask('Postcode');
            $transaction["bcountry"] = $bcountry; // TWO DIGIT COUNTRY (United States = "US")
            $transaction["bphone"] = $billingInfo->getByMask('Phone');
            $transaction["email"] = $billingInfo->getByMask('Email');

            $transaction["saddress1"] = $shippingInfo->getByMask('Streetline1');
            $transaction["saddress"] = $shippingInfo->getByMask('Streetline2');
            $transaction["scity"] = $shippingInfo->getByMask('City');
            $transaction["sstate"] = $sstate;
            $transaction["szip"] = $shippingInfo->getByMask('Postcode');
            $transaction["scountry"] = $scountry;
            $transaction["sphone"] = $shippingInfo->getByMask('Phone');
            $transaction["semail"] = $shippingInfo->getByMask('Email');

        //================================ transaction ===========================
            $content = "";
            foreach ($transaction as $key => $value) {
                $content .= $key . '=' . urlencode($value) . '&';
            }

            loadCoreFile('bouncer.php');
            $bnc = new Bouncer();
            $bnc->setMethod('POST');
            $bnc->setURL("https://transactions.innovativegateway.com/servlet/com.gateway.aai.Aai");
            $bnc->setPOSTstring($content);
            $result = $bnc->RunRequest();

        //================================ logging ===============================

            $transaction["ccnumber"] = preg_replace("/[0-9]/", 'x', $transaction["ccnumber"]);
            $transaction["month"] = preg_replace("/[0-9]/", 'x', $transaction["month"]);
            $transaction["year"] = preg_replace("/[0-9]/", 'x', $transaction["year"]);
            $transaction["ccidentifier1"] = preg_replace("/[0-9]/", 'x', $transaction["ccidentifier1"]);

            $msg = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");
            $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_TIMELINE_HEADER"), $transaction);

        //================================ logging ===============================

            if (isset($result["body"]))
            {
                $arrTemp = explode('|', $result["body"]);
                foreach ($arrTemp as $key => $value)
                {
                    $temp = explode('=', $value);
                    if (isset($temp[1]))
                        $arrRlt[_ml_strtolower($temp[0])] = urldecode($temp[1]);
                }
            }
            else
            {
                $arrRlt["error"] = $msgObj->getMessage("ERROR_NO_RESPONSE");
            }

        //================================ logging ===============================

            $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_TIMELINE_HEADER"), $arrRlt);

        //================================ logging ===============================
        }
        else
        {
            $msgObj = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");
            $arrRlt["error"] = $msgObj->getMessage("ERROR_CARD_TYPE_NOT_ALLOWABLE");
            $arrRlt["error"] = str_replace("CARD_TYPE", $cardType, $arrRlt["error"]);
        }

        $msgObj = $application->getInstance("MessageResources", "payment-module-innovative-messages", "AdminZone");
        if (!isset($arrRlt["error"])
            && (isset($arrRlt["approval"])
            || isset($arrRlt["test_override_errors"])))
            // Successful Payment, APPROVED
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => $arrRlt, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // NO RESPONSE, DECLINED or FRAUD
        {
            $msg = $msgObj->getMessage("ERROR_SERVER_RESULT");
            if (isset($arrRlt["error"]))
            {
                $msg .= "<br/>\n" . $arrRlt["error"];
            }

            $this->setErrorMessage($msg);

            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
        return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_innovative_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_innovative_setting_id'
               ,'key'               => $settings.'.pm_innovative_setting_key'
               ,'value'             => $settings.'.pm_innovative_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        YourPay                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-innovative-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_INNOVATIVE_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>