<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleLinkpointCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Linkpoint_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * PaymentModuleLinkpoint  constructor.
     */
    function Payment_Module_Linkpoint_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-linkpoint-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }


    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'LinkpointErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'LinkpointErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'LinkpointErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'LinkpointErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'LinkpointErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-linkpoint-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_LINKPOINT_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_LINKPOINT_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Linkpoint_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-linkpoint-messages", "AdminZone");

        $tables = Payment_Module_Linkpoint_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_linkpoint_settings';            #
        $columns = $tables[$table]['columns'];  #

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MERCHANT_CODE", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MERCHANT_CODE')).':"'.$obj->getMessage('MERCHANT_CODE').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_CERTIFICATE", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_CERTIFICATE')).':"'.$obj->getMessage('MODULE_CERTIFICATE').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("GATEWAY_URL", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('GATEWAY_URL')).':"'.$obj->getMessage('GATEWAY_URL').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("GATEWAY_PORT", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('GATEWAY_PORT')).':"'.$obj->getMessage('GATEWAY_PORT').'";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Linkpoint_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Linkpoint UID
//        return "EF77F26F-03C2-4650-B919-F168CD0B0551";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-linkpoint-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "linkpoint_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleLinkpointCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleLinkpointCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_linkpoint_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_linkpoint_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_linkpoint_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_linkpoint_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_linkpoint_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_linkpoint_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL();

        $confirmationData = array
            (
                "FormAction" => $self_link
                ,"FormMethod" => "POST"
                ,"DataFields" => array()
            );

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-linkpoint-messages", "AdminZone");

        //
        // The checking on the delivery to the selected place might be
        // added here
        //
        if (isset($data["_POST"]["r_ordernum"]))
        {
        	modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $data["_POST"]["r_ordernum"]);
        }
        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_LINKPOINT_LOG_EVENT_DESCRIPTION') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_LINKPOINT_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);

        if (isset($data["_POST"]["r_error"])
        	&& $data["_POST"]["r_error"] == ''
        	&& isset($data["_POST"]["r_approved"])
        	&& _ml_strtoupper($data["_POST"]["r_approved"]) == "APPROVED")
       	{
	        $EventType = "ConfirmationSuccess";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
       	}
       	else
       	{
	        $EventType = "ConfirmationFailure";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
       	}
	    return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Linkpoint_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Linkpoint_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());

        $cardNumber = isset($CCInfo["CreditCardNumber"]["value"])
            ? $CCInfo["CreditCardNumber"]["value"] : "";
        $CVM = isset($CCInfo["CreditCardVerificationNumber"]["value"])
            ? $CCInfo["CreditCardVerificationNumber"]["value"] : "";

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        // notice: a two-digit year
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? $CCInfo["ExpirationYear"]["value"] % 100 : "";

        $certificate = isset($this->Settings['MODULE_CERTIFICATE'])
            ? $this->Settings['MODULE_CERTIFICATE'] : "";

        $userid      = "";
        $oid         = "";
        $ip          = $_SERVER["REMOTE_ADDR"];
        $phone       = $billingInfo->getByMask('Phone');
        $email       = $billingInfo->getByMask('Email');

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $chargeTotal = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id));
        $tax         = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Tax", $currency_id));
        $shipping    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingCharge", $currency_id));
        $subtotal    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal", $currency_id));

        $merchantCode = $this->Settings['MERCHANT_CODE'];
        $gatewayUrl  = $this->Settings["GATEWAY_URL"];
        $gatewayPort = $this->Settings["GATEWAY_PORT"];

        $bname =     $billingInfo->getByMask('Firstname')." ".$billingInfo->getByMask('Lastname');
        $baddress1 = $billingInfo->getByMask('Streetline1');
        $baddress2 = $billingInfo->getByMask('Streetline2');
        $bcity =     $billingInfo->getByMask('City');
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bzip =      $billingInfo->getByMask('Postcode');
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');

        $sname =     $shippingInfo->getByMask('Firstname')." ".$shippingInfo->getByMask('Lastname');
        $saddress1 = $shippingInfo->getByMask('Streetline1');
        $saddress2 = $shippingInfo->getByMask('Streetline2');
        $scity =     $shippingInfo->getByMask('City');
        $sstate =    $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext');
        $szip =      $shippingInfo->getByMask('Postcode');
        $scountry =  $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country');

        $fileContent = file_get_contents(dirname(__FILE__)."/includes/templateRequest.xml");
        $requestBody = str_replace(
            array(
                'LINKPOINT_XML_STORENUMBER'
               ,'LINKPOINT_XML_OID'
               ,"LINKPOINT_XML_IP"
               ,"LINKPOINT_XML_SUBTOTAL"
               ,"LINKPOINT_XML_SHIPPING"
               ,"LINKPOINT_XML_TAX"
               ,'LINKPOINT_XML_CHARGETOTAL'
               ,'LINKPOINT_XML_CARDNUMBER'
               ,'LINKPOINT_XML_CARDEXPMONTH'
               ,'LINKPOINT_XML_CARDEXPYEAR'
               ,'LINKPOINT_XML_CVM'
               ,"LINKPOINT_XML_BNAME"
               ,"LINKPOINT_XML_BADDRESS1"
               ,"LINKPOINT_XML_BADDRESS2"
               ,"LINKPOINT_XML_BCITY"
               ,"LINKPOINT_XML_BSTATE"
               ,"LINKPOINT_XML_BZIP"
               ,"LINKPOINT_XML_BCOUNTRY"
               ,"LINKPOINT_XML_BPHONE"
               ,"LINKPOINT_XML_BEMAIL"
               ,"LINKPOINT_XML_BUSERID"
               ,"LINKPOINT_XML_SNAME"
               ,"LINKPOINT_XML_SADDRESS1"
               ,"LINKPOINT_XML_SADDRESS2"
               ,"LINKPOINT_XML_SCITY"
               ,"LINKPOINT_XML_SSTATE"
               ,"LINKPOINT_XML_SZIP"
               ,"LINKPOINT_XML_SCOUNTRY"
         )
           ,array(
                utf8_encode($merchantCode)
               ,utf8_encode($oid)
               ,utf8_encode($ip)
               ,utf8_encode($subtotal)
               ,utf8_encode($shipping)
               ,utf8_encode($tax)
               ,utf8_encode($chargeTotal)
               ,utf8_encode($cardNumber)
               ,utf8_encode($cardExpMonth)
               ,utf8_encode($cardExpYear)
               ,utf8_encode($CVM)
               ,utf8_encode($bname)
               ,utf8_encode($baddress1)
               ,utf8_encode($baddress2)
               ,utf8_encode($bcity)
               ,utf8_encode($bstate)
               ,utf8_encode($bzip)
               ,utf8_encode($bcountry)
               ,utf8_encode($phone)
               ,utf8_encode($email)
               ,utf8_encode($userid)
               ,utf8_encode($sname)
               ,utf8_encode($saddress1)
               ,utf8_encode($saddress2)
               ,utf8_encode($scity)
               ,utf8_encode($sstate)
               ,utf8_encode($szip)
               ,utf8_encode($scountry)
               )
          , $fileContent
        );

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL("https://".$gatewayUrl.':'.$gatewayPort);
        $bnc->setSSLcert($certificate);
        $bnc->setPOSTstring($requestBody);
        $result = $bnc->RunRequest();

        $arrRlt = array();
        $result = explode("</", "r_smth>".$result["body"]);
        foreach ($result as $k => $val)
        {
            $val = explode("<", $val);
            if (isset($val[1]))
            {
                $val = explode(">", $val[1]);
                $arrRlt[$val[0]] = $val[1];
            }
        }

        $msgObj = $application->getInstance("MessageResources", "payment-module-linkpoint-messages", "AdminZone");
        if (isset($arrRlt["r_approved"])
            && $arrRlt["r_approved"] == "APPROVED") // APPROVED
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => $arrRlt, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // DECLINED or FRAUD
        {
            if (!isset($arrRlt["r_error"]))
	        {
	            // couldn't reach Linkpoint Gateway,
	            // looks like wrong gateway settings
	            $msg = $msgObj->getMessage("ERROR_NO_RESPONCE");
                $this->setErrorMessage($msg);
	        }
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT")
                    .$arrRlt["r_approved"]."<br />";
                if ($arrRlt["r_error"] != '') $msg .= $arrRlt["r_error"];
                if ($arrRlt["r_message"] != '') $msg .= "<br />".$arrRlt["r_message"];
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
        return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_linkpoint_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_linkpoint_setting_id'
               ,'key'               => $settings.'.pm_linkpoint_setting_key'
               ,'value'             => $settings.'.pm_linkpoint_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Linkpoint                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-linkpoint-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_LINKPOINT_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>