<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update MerchantPlus settings.
 *
 * @package PaymentModuleMerchantPlus CC
 * @access  public
 * @author Girin Alexander
 */
class update_merchantplus_cc extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_merchantplus_cc()
    {
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_MerchantPlus_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"  => $SessionPost["ModuleName"]
//                         ,"MODULE_DESCR" => $SessionPost["ModuleDescr"]
                         ,"MODULE_LOGIN" => $SessionPost["ModuleLogin"]
                         ,"MODULE_KEY"   => $SessionPost["ModuleKey"]
                         ,"MODULE_HASH_VALUE"=> $SessionPost["ModuleHashValue"]
                         ,"MODULE_MODE"  => $SessionPost["ModuleMode"]
                         ,"MODULE_CART"  => $SessionPost["ModuleCart"]
                         ,"MODULE_URL"   => _ml_substr($SessionPost["ModuleUrl"], ($pos = _ml_strpos($SessionPost["ModuleUrl"], "//")? ($pos+2):0))
                         );
        modApiFunc("Payment_Module_MerchantPlus_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                $nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo, CreditCardInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo", "creditCardInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (array_key_exists("ModuleName", $SessionPost) != true || trim($SessionPost["ModuleName"]) == "")
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }
                if (array_key_exists("ModuleLogin", $SessionPost) != true || trim($SessionPost["ModuleLogin"]) == "")
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_LOGIN";
                }
                if (array_key_exists("ModuleKey", $SessionPost) != true || $SessionPost["ModuleKey"] == "")
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_KEY";
                }
                if (array_key_exists("ModuleUrl", $SessionPost) != true || trim($SessionPost["ModuleUrl"]) == "")
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_URL";
                }
                else
                {
                    //validate url
                    //
                    $urlString = "https://" . $SessionPost["ModuleUrl"];
                    loadCoreFile("URI.class.php");
                    $url = new URI($urlString);
                    if ($url == NULL)
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_MALFORMED_URL";
                    }
                    else if ($url->getPart("host") == NULL ||
                        $url->getPart("user") != NULL ||
                        $url->getPart("pass") != NULL ||
                        $url->getPart("query") != NULL )
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_MALFORMED_URL";
                    }
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);
                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>