<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleMonerisCC
 * @author Ravil Garafutdinov
 */

//
_use(dirname(__FILE__)."/includes/mpgClasses.php");


class Payment_Module_Moneris_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * PaymentModuleMoneris  constructor.
     */
    function Payment_Module_Moneris_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneris-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'MonerisErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'MonerisErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'MonerisErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'MonerisErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'MonerisErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneris-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_MONERIS_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_MONERIS_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Moneris_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneris-messages", "AdminZone");

        $tables = Payment_Module_Moneris_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_moneris_settings';            #
        $columns = $tables[$table]['columns'];  #

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("STORE_ID", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('STORE_ID')).':"'.$obj->getMessage('STORE_ID').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("API_TOKEN", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('API_TOKEN')).':"'.$obj->getMessage('API_TOKEN').'";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Moneris_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Moneris UID
//        return "879BB5C2-FED1-4EA4-B17A-2E7119B95B43";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneris-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "moneris_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleMonerisCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleMonerisCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_moneris_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_moneris_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_moneris_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_moneris_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_moneris_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_moneris_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL();

        $confirmationData = array
            (
                "FormAction" => $self_link
                ,"FormMethod" => "POST"
                ,"DataFields" => array()
            );

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-moneris-messages", "AdminZone");

        //
        // The checking on the delivery to the selected place might be
        // added here
        //
        if (isset($data["_POST"]["ResponseCode"]))
        {
        	modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $this->MessageResources->getMessage(sprintf("CARD_RESPONSE_%03d", $data["_POST"]["ResponseCode"])));
        }
        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_MONERIS_LOG_EVENT_DESCRIPTION') . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_MONERIS_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);

        if (isset($data["_POST"]["ResponseCode"])
        	&& $data["_POST"]["ResponseCode"] < 50)
       	{
	        $EventType = "ConfirmationSuccess";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
       	}
       	else
       	{
	        $EventType = "ConfirmationFailure";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
       	}
	    return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Moneris_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Moneris_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());

        $cardNumber = isset($CCInfo["CreditCardNumber"]["value"])
            ? $CCInfo["CreditCardNumber"]["value"] : "";
        $CVM = isset($CCInfo["CreditCardVerificationNumber"]["value"])
            ? $CCInfo["CreditCardVerificationNumber"]["value"] : "";

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        // notice: a two-digit year
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? $CCInfo["ExpirationYear"]["value"] % 100 : "";
        // yymm
        $cardExpDate = sprintf("%02d%02d", intval($cardExpYear), intval($cardExpMonth));

//====================================================================

		// ------ Define all the required variables. These can be passed by whatever means you wish
//		$customerId = "avactis test";// put real last name and first name
		$customerId = $billingInfo->getByMask('Lastname')." ".$billingInfo->getByMask('Firstname');
		$storeId = $this->Settings["STORE_ID"];// test value - "store1";//
		$apiToken = $this->Settings["API_TOKEN"];// test value - "yesguy";//
        $orderId = date("YmdHis").intval(microtime()*1000000);
//		$pan = "5454545454545454";  // test MasterCard number
//		$amount = "2.22";    // x.00 for APPROVED, x.22 for DECLINED - test account only
		$amount = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid())));
		$cryptType = "7";        // SSL without authorization

		$mpgCustInfo = @new mpgCustInfo();

		$email = "";
		$email .= $billingInfo->getByMask('Email');
		if ($shippingInfo->getByMask('Email') != ''
		    && $billingInfo->getByMask('Email') != $shippingInfo->getByMask('Email'))
		{
		    if ($billingInfo->getByMask('Email') != '')
		        $email .= ", ";

		    $email .= $shippingInfo->getByMask('Email');
		}
		$mpgCustInfo->setEmail($billingInfo->getByMask('Email'));

		$instructions = "";
		if ($billingInfo->getByMask("CommentLine") != '')
		    $instructions .= $billingInfo->getByMask("CommentLine");
		if ($billingInfo->getByMask("CommentArea") != '')
		    $instructions .= "\n".$billingInfo->getByMask("CommentArea");
		if ($shippingInfo->getByMask("CommentLine") != '')
		    $instructions .= "\n".$shippingInfo->getByMask("CommentLine");
		if ($shippingInfo->getByMask("CommentArea") != '')
		    $instructions .= "\n".$shippingInfo->getByMask("CommentArea");

		@$mpgCustInfo->setInstructions($instructions);

		$billing = array("first_name" => $billingInfo->getByMask('Firstname'),
						"last_name" => $billingInfo->getByMask('Lastname'),
						"company_name" => "",//'Widget Company Inc.',
						"address" => $billingInfo->getByMask('Streetline1')." ".$billingInfo->getByMask('Streetline2'),
						"city" => $billingInfo->getByMask('City'),
						"province" => modApiFunc("Location", "getState", $billingInfo->getByMask('Statemenu')),
						"postal_code" => $billingInfo->getByMask('Postcode'),
						"country" => modApiFunc("Location", "getCountry", $billingInfo->getByMask('Country')),
						"phone_number" => $billingInfo->getByMask('Phone'),
						"fax" => "",//'416-555-5555',
						"tax1" => "",//'123.45',
						"tax2" => "",//'12.34',
						"tax3" => "",//'15.45',
						"shipping_cost" => $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingCharge", modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid())))//'456.23'
		            );
		@$mpgCustInfo->setBilling($billing);

		$shipping = array("first_name" => $shippingInfo->getByMask('Firstname'),
						"last_name" => $shippingInfo->getByMask('Lastname'),
						"company_name" => "",//'Widget Company Inc.',
						"address" => $shippingInfo->getByMask('Streetline1')." ".$shippingInfo->getByMask('Streetline2'),
						"city" => $shippingInfo->getByMask('City'),
						"province" => modApiFunc("Location", "getState", $shippingInfo->getByMask('Statemenu')),
						"postal_code" => $shippingInfo->getByMask('Postcode'),
						"country" => modApiFunc("Location", "getCountry", $shippingInfo->getByMask('Country')),
						"phone_number" => $shippingInfo->getByMask('Phone'),
						"fax" => "",//'416-555-5555',
						"tax1" => '', // ------ leave blank   use billing above for these values
						"tax2" => '', //------ leave blank   use billing above for these values
						"tax3" => '', //------ leave blank   use billing above for these values
						"shipping_cost" => ''); //------ leave blank   use billing above for these values
		@$mpgCustInfo->setShipping($shipping);

		// ------ step 1) create transaction hash
		$txnArray=array(
			"type" => 'purchase',
			"order_id" => $orderId,
			"cust_id" => $customerId,
			"amount" => $amount,
			"pan" => $cardNumber,
			"expdate" => $cardExpDate,
			"crypt_type" => $cryptType
		);

		// ------ step 2) create a transaction object passing the hash created in step 1.
		$mpgTxn = @new mpgTransaction($txnArray);
		@$mpgTxn->setCustInfo($mpgCustInfo);

		// ------ step 3) create a mpgRequest object passing the transaction object created in step 2
		@$mpgRequest = new mpgRequest($mpgTxn);

		// ------ step 4) create mpgHttpsPost object which does an https post
		@$mpgHttpPost =new mpgHttpsPost($storeId,$apiToken,$mpgRequest);

		// ------ step 5) get an mpgResponse object
		@$mpgResponse=$mpgHttpPost->getMpgResponse();

    //================================ logging ===============================

        $txnArray["pan"] = preg_replace("/[0-9]/", 'x', $txnArray["pan"]);
        $txnArray["expdate"] = preg_replace("/[0-9]/", 'x', $txnArray["expdate"]);

        $fields = array_merge($billing, $shipping);
        $fields = array_merge($fields, $txnArray);

        $msgObj = $application->getInstance("MessageResources", "payment-module-moneris-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER"), $fields);

    //================================ logging ===============================

		// ------ step 6) retrieve data using get methods. Using these methods you can retrieve the
		// ------ appropriate variables (getResponseCode) to check if the transactions is approved
		// ------ (=>0 or <50) or declined (>49) or incomplete (NULL)
		if ($mpgResponse != NULL)
		{
			$resp = array(
				"CardType" => $mpgResponse->getCardType(),
				"TransAmount" => $mpgResponse->getTransAmount(),
				"TxnNumber" => $mpgResponse->getTxnNumber(),
				"ReceiptId" => $mpgResponse->getReceiptId(),
				"TransType" => $mpgResponse->getTransType(),
				"ReferenceNum" => $mpgResponse->getReferenceNum(),
				"ResponseCode" => $mpgResponse->getResponseCode(),
				"ISO" => $mpgResponse->getISO(),
				"Message" => $mpgResponse->getMessage(),
				"AuthCode" => $mpgResponse->getAuthCode(),
				"Complete" => $mpgResponse->getComplete(),
				"TransDate" => $mpgResponse->getTransDate(),
				"TransTime" => $mpgResponse->getTransTime()
			);

        //================================ logging ===============================

            $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER"), $resp);

        //================================ logging ===============================

			$rlt = $resp["ResponseCode"];
			$complete = $resp["Complete"];
		}
		else
		{
		    $rlt = "false";
		    $complete = "false";
		}

//====================================================================

        if ($rlt != "false" && $complete != "false" && 0 <= $rlt && $rlt < 50) // APPROVED
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => $resp, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // DECLINED or FRAUD
        {
            if ($rlt == "false")
	        {
	            // couldn't reach Moneris Gateway,
	            // looks like wrong gateway settings
	            $msg = $msgObj->getMessage("ERROR_NO_RESPONCE");
                $this->setErrorMessage($msg);
	        }
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT")
                    .$mpgResponse->getMessage()."<br />";
                if ($rlt != "null") $msg .= $msgObj->getMessage(sprintf("CARD_RESPONSE_%03d", $rlt));
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ('step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
            return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_moneris_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_moneris_setting_id'
               ,'key'               => $settings.'.pm_moneris_setting_key'
               ,'value'             => $settings.'.pm_moneris_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        YourPay                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-moneris-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_MONERIS_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }


    /**
     * this function returns current Moneris eSELECTplus API version
     */
    function getApiVersion()
    {
        $mnrGlobals = new mpgGlobals();
        $apiProps = $mnrGlobals->getGlobals();
        return $apiProps["API_VERSION"];
    }

    /**
     * this function returns current Moneris eSELECTplus host name
     */
    function getMonerisHost()
    {
        $mnrGlobals = new mpgGlobals();
        $apiProps = $mnrGlobals->getGlobals();
        return $apiProps["MONERIS_HOST"];
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>