<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModulePayflowproCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Payflowpro_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * PaymentModulePayflowpro  constructor.
     */
    function Payment_Module_Payflowpro_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-payflowpro-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'PayflowproErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'PayflowproErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'PayflowproErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'PayflowproErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'PayflowproErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-payflowpro-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_PAYFLOWPRO_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_PAYFLOWPRO_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Payflowpro_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-payflowpro-messages", "AdminZone");

        $tables = Payment_Module_Payflowpro_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_payflowpro_settings';                #the name of the filled table
        $columns = $tables[$table]['columns'];      #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_USERNAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_USERNAME')).':"'.$obj->getMessage('MODULE_USERNAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_PASSWORD')).':"'.$obj->getMessage('MODULE_PASSWORD').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_PARTNER", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_PARTNER')).':"'.$obj->getMessage('MODULE_PARTNER').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_DESCRIPTION", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_MERCHANT_DESCRIPTION')).':"'.$obj->getMessage('MODULE_MERCHANT_DESCRIPTION').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_CART", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(8, $columns['id']);
        $query->addInsertValue("GATEWAY_URL_TEST", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('GATEWAY_URL_TEST')).':"'.$obj->getMessage('GATEWAY_URL_TEST').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(9, $columns['id']);
        $query->addInsertValue("GATEWAY_URL_LIVE", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('GATEWAY_URL_LIVE')).':"'.$obj->getMessage('GATEWAY_URL_LIVE').'";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Payflowpro_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Payflowpro UID
//        return "3AAB63AF-7BBB-4A2C-9D9A-F1FA1E6345CA";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-payflowpro-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "payflowpro_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModulePayflowproCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModulePayflowproCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_payflowpro_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_payflowpro_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_payflowpro_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_payflowpro_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_payflowpro_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_payflowpro_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        print "ERROR! getConfirmationData call!";die;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $msgRes = &$application->getInstance('MessageResources',"payment-module-payflowpro-messages", "AdminZone");

        $msg = $this->OrderHistoryMessageTag."\n"
            .$this->getmicrotime()."\n"
            .$msgRes->getMessage('MODULE_PAYMENT_PAYFLOWPRO_LOG_EVENT_DESCRIPTION')."\n"
            .$msgRes->getMessage('MODULE_PAYMENT_PAYFLOWPRO_LOG_POST_DATA')."\n"
            .print_r($data["_POST"], true);

        $txn = $data["_POST"]["Result"];
        if ($txn === "0")
        {
            $EventType = "ConfirmationSuccess";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
        }
        else if ($txn === false)
        {
            $msg .= $msgRes->getMessage('MODULE_PAYMENT_PAYFLOWPRO_LOG_POST_DATA')."\n"
                .print_r($data["_POST"], true);
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
            $EventType = "ConfirmationFailure";
        }
        else
        {
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
            $EventType = "ConfirmationFailure";
        }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Payflowpro_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Payflowpro_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }


    /**
     * forms and returns properly formatted cart items list
     * returns "" if "pass items" option is off
     *
     * @return unknown
     */

    function getCartItems()
    {
        $settings = $this->getSettings();
        if ($settings["MODULE_CART"] != 1)
            return "";

        $i=1;
        $retval = "";
        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);
        $cart = modApiFunc("Cart", "getCartContent", $currency_id);
        $item_tpl = file_get_contents(dirname(__FILE__)."/includes/itemsPartialRequest.xml");

        foreach ($cart as $item)
        {
            $fields = array (
                 "ITEM_NUMBER"  => $i
                ,"ITEM_SKU"     => $item["SKU"]
                ,"ITEM_DESCR"   => $item["Name"]
                ,"ITEM_QUANT"   => $item["Quantity_In_Cart"]
                ,"ITEM_PRICE"   => modApiFunc("Localization", "num_format", $item["Total"])
            );

            $i++;
            $item = $item_tpl;
            $item = strtr($item, $fields);
            $retval .= $item."\n";
        }
        $retval = "<Items>\n$retval                            </Items>";

        return $retval;
    }


    /**
     * processes up to three direct payment requests, if necessary
     * also fills in $this->response with parsed result
     *
     * @return $result["body"] or false
     */

    function doDirectPaymentRequest()
    {
        global $application;
        loadCoreFile('aal.class.php');
        loadCoreFile('bouncer.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $settings = $this->getSettings();
        $cardInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());

        $url = ($settings["MODULE_MODE"] == 1) ? $settings["GATEWAY_URL_TEST"] : $settings["GATEWAY_URL_LIVE"];

        $comment = "";
        if ($billingInfo->getByMask('CommentLine') != "")
            $comment .= $billingInfo->getByMask('CommentLine');
        if ($billingInfo->getByMask('CommentArea') != "")
            $comment .= " ".$billingInfo->getByMask('CommentArea');
        if ($shippingInfo->getByMask('CommentLine') != "")
            $comment .= " ".$shippingInfo->getByMask('CommentLine');
        if ($shippingInfo->getByMask('CommentArea') != "")
            $comment .= " ".$shippingInfo->getByMask('CommentArea');
        $comment = trim($comment);

        $request_id = date("YmdHis").intval(microtime()*1000000);

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
        $total       = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId));

        $dataFields = array
            (
                "VENDOR"               => $settings["MODULE_USERNAME"]
               ,"PARTNER"              => $settings["MODULE_PARTNER"]
               ,"REQUEST_ID"           => $request_id
               ,"CUSTIP"               => $_SERVER['REMOTE_ADDR']
               ,"MERCHANTDESCRIPTION"  => $settings["MODULE_MERCHANT_DESCRIPTION"]
               ,"BNAME"                => $billingInfo->getByMask("Firstname")." ".$billingInfo->getByMask("Lastname")
               ,"BSTREET"              => $billingInfo->getByMask("Streetline1")." ".$billingInfo->getByMask("Streetline2")
               ,"BCITY"                => $billingInfo->getByMask("City")
               ,"BSTATE"               => ($billingInfo->getByMask('Statemenu')) ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext')
               ,"BZIP"                 => $billingInfo->getByMask('Postcode')
               ,"BCOUNTRY"             => $billingInfo->getByMask('Country')//($billingInfo->getByMask('Country')) ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : ""
               ,"BEMAIL"               => $billingInfo->getByMask("Email")
               ,"BPHONE"               => $billingInfo->getByMask("Phone")
               ,"SNAME"                => $shippingInfo->getByMask("Firstname")." ".str_replace("&", "%amp;", $shippingInfo->getByMask("Lastname"))
               ,"SSTREET"              => $shippingInfo->getByMask("Streetline1")." ".$shippingInfo->getByMask("Streetline2")
               ,"SCITY"                => $shippingInfo->getByMask('City')
               ,"SSTATE"               => ($shippingInfo->getByMask('Statemenu')) ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext')
               ,"SZIP"                 => $shippingInfo->getByMask('Postcode')
               ,"SCOUNTRY"             => ($shippingInfo->getByMask('Country')) ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : ""
               ,"SEMAIL"               => $shippingInfo->getByMask("Email")
               ,"SPHONE"               => $shippingInfo->getByMask("Phone")
               ,"<ITEMS/>"             => $this->getCartItems()
               ,"CURRENCY_CODE"        => $currencyCode
               ,"TOTALAMT"             => $total
               ,"COMMENT"              => $comment
               ,"CARDNUM"              => $cardInfo["CreditCardNumber"]["value"]
               ,"EXPDATE"              => $cardInfo["ExpirationYear"]["value"].$cardInfo["ExpirationMonth"]["value"]
               ,"CVNUM"                => $cardInfo["CreditCardVerificationNumber"]["value"]
               ,"USER"                 => $settings["MODULE_USERNAME"]
               ,"PASSWORD"             => $settings["MODULE_PASSWORD"]
           );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/templateRequest.xml");
        $xml_content = strtr($xml_content, $dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($url);
        $bnc->setPOSTstring($xml_content);

    //=========================== logging request ========================

        $dataFields['CARDNUM'] = preg_replace('/[0-9]/', 'x', $dataFields['CARDNUM']);
        $dataFields['CVNUM'] = preg_replace('/[0-9]/', 'x', $dataFields['CVNUM']);
        $dataFields['EXPDATE'] = preg_replace('/[0-9]/', 'x', $dataFields['EXPDATE']);
        $xml_logged = file_get_contents(dirname(__FILE__)."/includes/templateRequest.xml");
        $xml_logged = strtr($xml_logged, $dataFields);

        $msgObj = $application->getInstance("MessageResources", "payment-module-payflowpro-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_REQUEST"), prepareArrayDisplay($xml_logged));

    //=========================== logging request ========================

        // PayPal engineers advice to make three or more transactions
        // if the first one was unsuccessful.
        // If the txn was successful, but it's response was lost,
        // the next identical request will have the same response
        // marked as "duplicate", with no actions applied
        for ($i=0; $i < 3; $i++)
        {
            $result = $bnc->RunRequest();
            if ($result)
            {
            //=========================== logging request ========================

                $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_RESPONSE"), prepareArrayDisplay($result));

            //=========================== logging request ========================

                $this->response = $this->parseResponse($result["body"]);
                return $result["body"];
            }
        }
        return false;
    }

    function getStatusRequest($pnref)
    {
        if (!$pnref)
            return false;

        loadCoreFile('bouncer.php');

        $settings = $this->getSettings();
        $request_id = date("YmdHis").intval(microtime()*1000000);
        $url = ($settings["MODULE_MODE"] == 1) ? $settings["GATEWAY_URL_TEST"] : $settings["GATEWAY_URL_LIVE"];

        $dataFields = array
            (
                "VENDOR"               => $settings["USERNAME"]
               ,"PARTNER"              => $settings["PARTNER"]
               ,"REQUEST_ID"           => $request_id
               ,"PNREF"                => $pnref
               ,"USER"                 => $settings["USERNAME"]
               ,"PASSWORD"             => $settings["PASSWORD"]
           );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/getStatusRequest.xml");
        $xml_content = strtr($xml_content, $dataFields);
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($url);
        $bnc->setPOSTstring($xml_content);

        // PayPal engineers advice to make three or more transactions
        // if the first one was unsuccessful.
        // If the trx was successful, but it's responce was lost,
        // the next identical request will have the same responce
        // marked as "duplicate", with no actions applied
        for ($i=0; $i < 3; $i++)
        {
            $result = $bnc->RunRequest();
            if ($result && isset($result["body"]))
            {
                $this->response = $this->parseResponse($result["body"]);
                return $result["body"];
            }
        }
        return false;
    }


    /**
     * gets a named tag
     *
     * @param fields to get $fields
     * @param char[] xml text $raw
     * @return $fields array
     */

    function parseXmlTags($fields, $raw)
    {
        loadCoreFile("obj_xml.php");
        $xml = new xml_doc($raw);
        $xml->parse();

        if (!is_object($xml->document))
            return $fields;

        $fields["XMLPayResponse"] = $xml->document->attributes;

        foreach ($fields as $tag => $val)
        {
            if (is_array($tag))
            {
                foreach ($fields[$tag] as $_tag => $_val)
                {
                    $xml_tag = $xml->document->findChildRecursively($_tag);
                    if ($xml_tag != FALSE)
                    {
                        if ($xml_tag->contents != "")
                            $fields[$tag][$_tag] = $xml_tag->contents;
                        else if ($xml_tag->attributes != "")
                            $fields[$tag][$_tag] = $xml_tag->attributes;
                     }
                }
                $xml_tag = $xml->document->findChildRecursively($tag);
            }
            else
            {
                $xml_tag = $xml->document->findChildRecursively($tag);
                if ($xml_tag != FALSE)
                {
                    if ($xml_tag->contents != "")
                        $fields[$tag] = $xml_tag->contents;
                    else if ($xml_tag->attributes != "")
                        $fields[$tag] = $xml_tag->attributes;
                }
            }
        }

        return $fields;
    }


    /**
     * parses response - xml content in, tags array out
     *
     * @param char[] xml text $raw
     * @return result $fields[]
     */

    function parseResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "XMLPayResponse" => false
            ,"Vendor" => false
            ,"Partner" => false
            ,"Result" => false
            ,"Message" => false
            ,"PNRef" => false
            ,"CVResult" => false
            ,"AuthCode" => false
        );

        return $this->parseXmlTags($fields, $raw);
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        $txn = false;

        $rawResult = $this->doDirectPaymentRequest();
        $result = $dprResult = $this->response;
        $result["raw"] = htmlspecialchars($rawResult);
        $txn = ($result != false && isset($result["Result"])) ? $result["Result"] : false;
        if ($txn == 30) // TIMEOUT
        {
            $gsResult = $this->getStatusRequest($result["PNRef"]);
            if ($gsResult != false)
            {
                $result = $this->response;
                $result["raw"] = htmlspecialchars($gsResult);
                $txn = $result["Result"];
            }
        }

        $msgObj = $application->getInstance("MessageResources", "payment-module-payflowpro-messages", "AdminZone");
    //================================================================================================
    //                 APPROVED via doDirectRequest or getStatusRequest
    //================================================================================================
        if ($txn === "0") // APPROVED
        {
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            modApiFunc("Cart", "removeAllFromCart");

            $this->processData(array("_POST" => $result, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else
        {
    //================================================================================================
    //                 unsuccessful transaction, no reply
    //================================================================================================
            if ($txn === false)
            {
                $msg = $msgObj->getMessage("ERROR_NO_RESPONSE");
                $this->setErrorMessage($msg);
            }
    //================================================================================================
    //                 unsuccessful transaction, errors
    //================================================================================================
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT");
                $msg .= "\n".$result["Message"];
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }

        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ('step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
        return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_payflowpro_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_payflowpro_setting_id'
               ,'key'               => $settings.'.pm_payflowpro_setting_key'
               ,'value'             => $settings.'.pm_payflowpro_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        YourPay                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-payflowpro-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_PAYFLOWPRO_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $response;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>