<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update Paymate settings.
 *
 * @package PaymentModulePaymateCC
 * @access  public
 * @author Egor Makarov
 */
class update_paymate extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_paymate()
    {
    }


    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_Paymate_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array
            (
                "MODULE_NAME"  => $SessionPost["ModuleName"]
//              ,"MODULE_DESCR" => $SessionPost["ModuleDescr"]
                ,"MODULE_ID" => $SessionPost["ModuleId"]
                ,"MODULE_EMAIL" => $SessionPost["ModuleEmail"]
                ,"MODULE_MODE" => $SessionPost["ModuleMode"]
//              ,"MODULE_ORDER_STATUS_ID" => $SessionPost["ModuleOrderStatusId"]
            );

        modApiFunc("Payment_Module_Paymate_CC", "updateSettings", $Settings);
    }

    function isValidEmail($email)
    {
        return preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,6})$/i", $email);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                //$nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (empty($SessionPost["ModuleName"]) == true || trim($SessionPost["ModuleName"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }

                $supportedCurrencies = array("AUD", "USD");
                $main_currency_id = modApiFunc("Localization", "getMainStoreCurrency");
                $localCurrencyCode = modApiFunc("Localization", "getCurrencyCodeById", $main_currency_id);

                if ($SessionPost["status"] == "active")
                {
                    if ($SessionPost["ModuleMode"] == "2")
                    {
                        // testing mode parameters are in the initial mode, so in
                        // the production mode only all the fields must be filled out.
                if (empty($SessionPost["ModuleId"]) == true || trim($SessionPost["ModuleId"]) == '')
                {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_ID";
                }
                if (empty($SessionPost["ModuleEmail"]) == true || !$this->isValidEmail(trim($SessionPost["ModuleEmail"])))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_INVALID_EMAIL";
                }
                    }
                    if (in_array($localCurrencyCode, $supportedCurrencies) == false)
                    {
                    	$SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_INVALID_CURRENCY";
                    }
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if ($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>