<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for updating PaypalPro UK settings.
 *
 * @package PaymentModulePaypalPro_UK CC
 * @access  public
 * @author Alexander Girin
 */
class update_paypalpro_uk extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_paypalpro_uk()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_PaypalPro_UK_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"  => $SessionPost["ModuleName"]
                         ,"EXPRESS_CHECKOUT_METHOD_NAME" => $SessionPost["ExpressCheckoutMethodName"]
                         ,"DIRECT_PAYMENT_METHOD_NAME" => $SessionPost["DirectPaymentMethodName"]
                         ,"USERNAME" => $SessionPost["Username"]
                         ,"PASSWORD" => $SessionPost["Password"]
                         ,"PARTNER" => $SessionPost["Partner"]
                         ,"MERCHANT_DESCRIPTION" => $SessionPost["MerchantDescription"]
                         ,"MODULE_CART" => $SessionPost["ModuleCart"]
                         ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                         ,"ECHECKOUT_URL_TEST" => $SessionPost["EcheckoutUrlTest"]
                         ,"ECHECKOUT_URL_LIVE" => $SessionPost["EcheckoutUrlLive"]
                         ,"GATEWAY_URL_TEST" => $SessionPost["GatewayUrlTest"]
                         ,"GATEWAY_URL_LIVE" => $SessionPost["GatewayUrlLive"]
                         ,"MODULE_LOGO" => $SessionPost["ModuleLogo"]
                         ,"MODULE_3DS_ENABLE" => $SessionPost["Module3dsEnable"]
                         ,"MODULE_3DS_URL" => $SessionPost["Module3dsUrl"]
                         ,"MODULE_3DS_PROCESSOR_ID" => $SessionPost["Module3dsProcessorId"]
                         ,"MODULE_3DS_MERCHANT_ID" => $SessionPost["Module3dsMerchantId"]
                         ,"MODULE_3DS_TRANSACTION_PASSWORD" => $SessionPost["Module3dsTransactionPassword"]
                         );

        modApiFunc("Payment_Module_PaypalPro_UK_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
                $nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo, CreditCardInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo", "creditCardInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (empty($SessionPost["ModuleName"]) == true || trim($SessionPost["ModuleName"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }
                if (empty($SessionPost["ExpressCheckoutMethodName"]) == true || trim($SessionPost["ExpressCheckoutMethodName"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_EXPRESS_NAME";
                }
                if (empty($SessionPost["DirectPaymentMethodName"]) == true || trim($SessionPost["DirectPaymentMethodName"] == ''))
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_DIRECT_NAME";
                }

                if (!empty($SessionPost["Module3dsEnable"]) && $SessionPost["Module3dsEnable"] == '1')
                {
                    if (empty($SessionPost["Module3dsUrl"]) == true || trim($SessionPost["Module3dsUrl"] == ''))
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_009";
                    }
                    if (empty($SessionPost["Module3dsProcessorId"]) == true || trim($SessionPost["Module3dsProcessorId"] == ''))
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_010";
                    }
                    if (empty($SessionPost["Module3dsMerchantId"]) == true || trim($SessionPost["Module3dsMerchantId"] == ''))
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_011";
                    }
                    if (empty($SessionPost["Module3dsTransactionPassword"]) == true || trim($SessionPost["Module3dsTransactionPassword"] == ''))
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_012";
                    }
                }

                if (empty($SessionPost["ModuleLogo"]) != true)
                {
                    // validate url
                    loadCoreFile("URI.class.php");
                    $url = new URI($SessionPost["ModuleLogo"]);
                    if ($url == NULL)
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_MALFORMED_IMG_URL";
                    }
                    else
                    {
                        if ($url->getPart("host") == NULL ||
                            $url->getPart("path") == NULL ||
                            $url->getPart("query") != NULL ||
                            $url->getPart("user") != NULL ||
                            $url->getPart("pass") != NULL ||
                            preg_match("/.\.(gif|jpg|jpeg|png|bmp)$/i", $url->getPart("path")) == NULL)
                        {
                            $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_MALFORMED_IMG_URL";
                        }
                    }
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;

            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        $Settings = modApiFunc("Payment_Module_PaypalPro_UK_CC", "getSettings");
        if (!$Settings['MODULE_BILLING_PERSON_INFO_VARIANT'])
        {
            modApiFunc("Payment_Module_PaypalPro_UK_CC", "updateSettings", array("MODULE_BILLING_PERSON_INFO_VARIANT" => modApiFunc("Payment_Module_PaypalPro_UK_CC", "setPersonInfoVariant", "billingInfo", "ExpressCheckout")));
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>