<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * CheckoutPaymentModulePaypalPro_UKCCOutput view.
 *
 * @package PaymentModulePaypalPro_UKCC
 * @author Alexander Girin
 */

class CheckoutPaymentModulePaypalProUKCCOutput
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Gets a template format for the given view.
     */
    function getTemplateFormat()
    {

    	$format = array(
    	    'layout-file'        => "checkout-payment-module-paypalpro_uk-cc-output-config.ini" //; $this->LayoutFile
    	   ,'files' => array(
    	        'OutputDirectPaymentContainer'               => TEMPLATE_FILE_SIMPLE
    	       ,'OutputExpressCheckoutContainer'             => TEMPLATE_FILE_SIMPLE
    	    )
    	   ,'options' => array(
    	    )
    	);
    	return $format;
    }

    /**
     *  CheckoutPaymentModulePaypalCCOutput constructor.
     */
    function CheckoutPaymentModulePaypalProUKCCOutput()
    {
        global $application;

//        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro_uk-messages", "AdminZone");

        #check if fatal errors exist in the block tag
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors($this->BlockTemplateName))
        {
            $this->NoView = true;
        }
    }

    /**
     *
     */
    function output()
    {
        if ($this->NoView)
        {
            return "";
        }

        global $application;
        $msg = &$application->getInstance("MessageResources");

        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate($this->BlockTemplateName);
        $this->templateFiller->setTemplate($this->template);

        $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
        $ModuleName = $ModuleInfo['Name'];

        if (modApiFunc("Payment_Module_PaypalPro_UK_CC", "getPaymentMethod") == "ExpressCheckout")
        {
            $this->_Template_Contents = array(
                                              "Local_PaymentMethodName" => $ModuleName
                                             );
            $application->registerAttributes($this->_Template_Contents);
            $retval = $this->templateFiller->fill("OutputExpressCheckoutContainer");
        }
        else
        {
            $this->_Template_Contents = array(
                                              "Local_PaymentMethodName" => ""
                                             ,'Local_CreditCardInfoOutput' => ""
                                             );
            $application->registerAttributes($this->_Template_Contents);
            $retval = $this->templateFiller->fill("OutputDirectPaymentContainer");
        }
        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        switch ($tag)
        {

            case 'Local_PaymentMethodName':
                $ModuleInfo = modApiFunc($this->ModuleAPIClassName, "getInfo");
                $value = $ModuleInfo['Name'];
                break;

            case 'Local_CreditCardInfoOutput':
                $moduleSettings = modApiFunc($this->ModuleAPIClassName, "getSettings");
                if (modApiFunc($this->ModuleAPIClassName, "getPaymentMethod") != "ExpressCheckout" && $application->getCurrentProtocol() != "http")
                {
                    $value = getCheckoutCreditCardInfoOutput(modApiFunc($this->ModuleAPIClassName, "getUid"));
                }
                break;

            default:
//                $value = $this->_Template_Contents[$tag];
                break;
        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $ModuleAPIClassName = "Payment_Module_PaypalPro_UK_CC";
    var $BlockTemplateName = "CheckoutPaymentModulePaypalProUKCCOutput";
    var $LayoutFile = "checkout-payment-module-paypalpro_uk-cc-output-config.ini";
//    var $BlockTemplateName = "CheckoutPaymentModulePaypalProCCOutput";
//    var $LayoutFile = "checkout-payment-module-paypalpro-cc-output-config.ini";
    /**#@-*/

}
?>