<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

//: move "defines" to member variables
define("PSIGATE_TEST_URL", "https://dev.psigate.com/HTMLPost/HTMLMessenger");
define("PSIGATE_TEST_STORE_KEY", "psigatecapturescard001010");
//define("PSIGATE_TEST_STORE_KEY", "merchantcardcapture200024");

/**
 *
 * @package PaymentModulePSiGateCC
 * @author Alexander Belyakov
 */
class Payment_Module_PSiGate_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Payment_Module_PSiGate_CC constructor.
     */
    function Payment_Module_PSiGate_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_PSIGATE_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_PSIGATE_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_PSIGATE_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_PSiGate_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-messages", "AdminZone");

        $tables = Payment_Module_PSiGate_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_psigate_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

/*
        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_URL", $columns['key']);
        $query->addInsertValue('s:46:"https://dev.psigate.com/HTMLPost/HTMLMessenger";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_STORE_KEY", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_CART", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_BILLING_INFO", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_SHIPPING_INFO", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(8, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_PSiGate_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_PSiGate_CC                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-psigate-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_PSIGATE_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "BE17C430-9581-11DB-B606-0800200C9A66";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-psigate-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModulePSiGateCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModulePSiGateCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModulePSiGateCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_psigate_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_psigate_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_psigate_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_psigate_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_psigate_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_psigate_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid()));
        $billingInfo = $orderInfo["Billing"]["attr"];

        $settings = $this->getSettings();

        $pm_url = '';
        $pm_sk = '';
        if ($settings['MODULE_MODE'] == '1')
        {
            $pm_url = PSIGATE_TEST_URL;
            $pm_sk = PSIGATE_TEST_STORE_KEY;
        }
        else
        {
            $pm_url = $settings["MODULE_URL"];
            $pm_sk = $settings["MODULE_STORE_KEY"];
        }

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $pm_currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);
        $confirmationData = array
            (
                "FormAction" => $pm_url
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                    //
                    // common info
                    //
                     "StoreKey"          => $pm_sk
                    ,"SubTotal"          => $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal", $currency_id))
                    ,"ShippingTotal"     => $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost", $currency_id))
                    ,"Tax1"              => $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "NotIncludedTax", $currency_id))
                    ,"FullTotal"         => $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id))
                    ,"CustomerRefNo"     => $orderId
                    ,"PaymentType"       => "CC"
                    ,"CardAction"        => "0"
                    ,"ThanksURL"         => $self_link
                    ,"NoThanksURL"       => $self_link
                    ,"popup"   => "false"
                )
            );

        $confirmationData["DataFields"]["Phone"] = isset($orderInfo["Customer"]["attr"]["Phone"]["value"])? $orderInfo["Customer"]["attr"]["Phone"]["value"]:"";
        $confirmationData["DataFields"]["Email"] = isset($orderInfo["Customer"]["attr"]["Email"]["value"])? $orderInfo["Customer"]["attr"]["Email"]["value"]:"";

        $discount = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountsSum", $currency_id));
        if ($this->Settings['MODULE_CART'] == 1)
        {
            $items = array();
            if ($discount == 0)
            {
                $n = 1;
                foreach ($orderInfo["Products"] as $productInfo)
                {
                    $sn = sprintf("%02d", $n);
                    $items["ItemID".$sn] = $productInfo["storeProductID"];
                    $items["Description".$sn] = prepareHTMLDisplay($productInfo["name"]);
                    $items["Quantity".$sn] = $productInfo["qty"];
                    $items["Price".$sn] = $productInfo["SalePrice"];
                    /*                 -
                    foreach ($productInfo["options"] as $i => $option)
                    {
                        if ($i == 24)
                        {
                            break;
                        }
                        $si = sprintf("%02d", $i+1);
                        $items["OptionName".$sn.$si] = prepareHTMLDisplay($option["option_name"]);
                        $items["OptionValue".$sn.$si] = prepareHTMLDisplay($option["option_value"]);
                    }
                    */
                    $n++;
                    if ($n == 25)
                    {
                        break;
                    }
                }
            }
            else
            {
                $items["ItemID01"] = 1;
                $items["Description01"] = modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_NAME);
                $items["Quantity01"] = 1;
                $items["Price01"] = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal", $currency_id));
            }
            $confirmationData["DataFields"] = array_merge($confirmationData["DataFields"], $items);
        }

        if ($this->Settings['MODULE_BILLING_INFO'] == 1)
        {
            $billingInfo = new ArrayAccessLayer($orderInfo);
            $billingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");

            $billingProvince = modApiFunc("Location", "getStateCodeByStateName", $billingInfo->getByMask("State"));
            if (!$billingProvince)
            {
                $billingProvince = $billingInfo->getByMask("State");
            }

            $confirmationData["DataFields"]["Bname"] = $billingInfo->getByMask("Firstname")." ".$billingInfo->getByMask("Lastname");
            $confirmationData["DataFields"]["Baddress1"] = $billingInfo->getByMask("Streetline1");
            $confirmationData["DataFields"]["Baddress2"] = $billingInfo->getByMask("Streetline2");
            $confirmationData["DataFields"]["Bcity"] = $billingInfo->getByMask("City");
            $confirmationData["DataFields"]["Bprovince"] = $billingProvince;
            $confirmationData["DataFields"]["Bpostalcode"] = $billingInfo->getByMask("Postcode");
            $confirmationData["DataFields"]["Bcountry"] = $billingInfo->getByMask("Country")? modApiFunc("Location", "getCountryCodeByCountryName", $billingInfo->getByMask("Country")):"";
        }

        if ($this->Settings['MODULE_SHIPPING_INFO'] == 1)
        {
            $shippingInfo = new ArrayAccessLayer($orderInfo);
            $shippingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");

            $shippingProvince = modApiFunc("Location", "getStateCodeByStateName", $shippingInfo->getByMask('State'));
            if (!$shippingProvince)
            {
                $shippingProvince = $shippingInfo->getByMask('State');
            }

            $confirmationData["DataFields"]["Sname"] = $shippingInfo->getByMask("Firstname")." ".$shippingInfo->getByMask("Lastname");
            $confirmationData["DataFields"]["Saddress1"] = $shippingInfo->getByMask("Streetline1");
            $confirmationData["DataFields"]["Saddress2"] = $shippingInfo->getByMask("Streetline2");
            $confirmationData["DataFields"]["Scity"] = $shippingInfo->getByMask("City");
            $confirmationData["DataFields"]["Sprovince"] = $shippingProvince;
            $confirmationData["DataFields"]["Spostalcode"] = $shippingInfo->getByMask("Postcode");
            $confirmationData["DataFields"]["Scountry"] = $shippingInfo->getByMask("Country")? modApiFunc("Location", "getCountryCodeByCountryName", $shippingInfo->getByMask("Country")):"";
        }

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, that came from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, that came from the payment gateway.
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-psigate-messages", "AdminZone");

        //
        // add incoming order message to history
        //
        $incommingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_MESSAGE_INCOMING') . "\n" .
            $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_EXTRA') . "\n" .
            print_r($data["_GET"], true);
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incommingHistoryMessage);

        //
        // check if necessary GET-parameters exist
        //
        $isGetValid = array_key_exists("Approved", $data["_GET"]) &&
            array_key_exists("CustomerRefNo", $data["_GET"]);

        if ($isGetValid)
        {
            $status = $data["_GET"]["Approved"];
            // the status update
            switch ($status)
            {
                case "APPROVED":
                    // the customer card has been approved
                    $EventType = "ConfirmationSuccess";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_MESSAGE_APPROVED'));
                    $PaymentProcessorOrderID = $data["_GET"]["OrderID"];;
                    modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $PaymentProcessorOrderID);
                    break;

                case "DECLINED":
                    // the payment request is declined
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_MESSAGE_DECLINED'));
                    break;

                case "ERROR":
                    // payment error
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_MESSAGE_ERROR'));
                    break;

                default:
                    // payment error
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_PSIGATE_LOG_MESSAGE_INVALID_STATUS') . $status);
                    break;
             }
        }
        else
        {
            $EventType = "ConfirmationFailure";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                $msg->getMessage("MODULE_PAYMENT_PSIGATE_LOG_MESSAGE_GET_ERROR"));
        }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_PSiGate_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_PSiGate_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_psigate_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_psigate_setting_id'
               ,'key'               => $settings.'.pm_psigate_setting_key'
               ,'value'             => $settings.'.pm_psigate_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    /**
     * Credit card info. It will be used later.
     */
    var $ccInfoCardNumber;
    var $ccInfoCardExpMonth;
    var $ccInfoCardExpYear;
    var $ccInfoCardIDNumber;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>