<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleSageCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Sage_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * PaymentModuleSage  constructor.
     */
    function Payment_Module_Sage_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-sage-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'SageErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'SageErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'SageErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'SageErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'SageErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-sage-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_SAGE_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_SAGE_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Sage_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-sage-messages", "AdminZone");

        $tables = Payment_Module_Sage_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_sage_settings';                #the name of the filled table
        $columns = $tables[$table]['columns'];      #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_KEY", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Sage_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Sage UID
//        return "8CC8A635-5183-43CC-B12D-DCB2B0B3AEEF";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-sage-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "sage_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleSageCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleSageCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_sage_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_sage_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_sage_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_sage_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_sage_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_sage_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        return;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $mres = &$application->getInstance('MessageResources',"payment-module-sage-messages", "AdminZone");

        //
        // The checking on the delivery to the selected place might be
        // added here
        //
        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $mres->getMessage('MODULE_PAYMENT_SAGE_LOG_EVENT_DESCRIPTION') . "\n" . $mres->getMessage('MODULE_PAYMENT_SAGE_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);

        if (isset($data["_POST"]["indicator"])
            && ($data["_POST"]["indicator"] == "A"))
        {
            $EventType = "ConfirmationSuccess";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);


            // Address Verification System message
            if (isset($data["_POST"]["avs_indicator"]))
            {
                $msg = $mres->getMessage("AVS_RESPONSE") . $data["_POST"]["avs_indicator"];
                $msg .= "\n" . $mres->getMessage("AVS_RESPONSE_" . $data["_POST"]["avs_indicator"]);
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }
            else
            {
                $msg = $mres->getMessage("AVS_NO_RESPONSE");
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }

            // Credit Card Verification Value message
            if (isset($data["_POST"]["cvv_indicator"]))
            {
                $msg = $mres->getMessage("CCV_RESPONSE") . $data["_POST"]["cvv_indicator"];
                $msg .= "\n" . $mres->getMessage("CCV_RESPONSE_" . $data["_POST"]["cvv_indicator"]);
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }
            else
            {
                $msg = $mres->getMessage("CCV_NO_RESPONSE");
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }

            // Risk Indicator message
            if (isset($data["_POST"]["risk_indicator"]))
            {
                $msg = $mres->getMessage("RISK_RESPONSE") . $data["_POST"]["risk_indicator"];
                $msg .= "\n" . $mres->getMessage("RISK_RESPONSE_" . $data["_POST"]["risk_indicator"]);
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }
            else
            {
                $msg = $mres->getMessage("RISK_NO_RESPONSE");
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
            }
        }
        else
        {
            $EventType = "ConfirmationFailure";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
        }
        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Sage_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Sage_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /**
     * parses XML tags, seeks for tags given in $fields
     *
     * @param string array $fields
     * @param string $raw
     * @return unknown
     */

    function parseXmlTags($fields, $raw)
    {
        loadCoreFile("obj_xml.php");
        $xml = new xml_doc($raw);
        $xml->parse();

        if (!is_object($xml->document))
            return $fields;

        foreach ($fields as $tag => $val)
        {
            $xml_tag = $xml->document->findChildRecursively($tag);
            if ($xml_tag != FALSE)
            {
                $fields[$tag] = $xml_tag->contents;
            }
        }

        return $fields;
    }

    function parseResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "ssl_card_number" => ""
            ,"ssl_exp_date" => ""
            ,"ssl_amount" => ""
            ,"ssl_salestax" => ""
            ,"ssl_company" => ""
            ,"ssl_first_name" => ""
            ,"ssl_last_name" => ""
            ,"ssl_avs_address" => ""
            ,"ssl_address2" => ""
            ,"ssl_city" => ""
            ,"ssl_state" => ""
            ,"ssl_avs_zip" => ""
            ,"ssl_country" => ""
            ,"ssl_phone" => ""
            ,"ssl_email" => ""
            ,"ssl_ship_to_company" => ""
            ,"ssl_ship_to_first_name" => ""
            ,"ssl_ship_to_last_name" => ""
            ,"ssl_ship_to_address1" => ""
            ,"ssl_ship_to_address2" => ""
            ,"ssl_ship_to_city" => ""
            ,"ssl_ship_to_state" => ""
            ,"ssl_ship_to_zip" => ""
            ,"ssl_ship_to_country" => ""
            ,"ssl_ship_to_phone" => ""
            ,"ssl_result" => ""
            ,"ssl_result_message" => ""
            ,"ssl_txn_id" => ""
            ,"ssl_approval_code" => ""
            ,"ssl_cvv2_response" => ""
            ,"ssl_avs_response" => ""
            ,"ssl_account_balance" => ""
            ,"ssl_txn_time" => ""
            ,"errorCode" => ""
            ,"errorName" => ""
            ,"errorMessage" => ""
        );

        return $this->parseXmlTags($fields, $raw);
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $sstate =    $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext');
        $scountry =  $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country');

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        $settings = $this->getSettings();
        $refnum =  date("YmdHis").intval(microtime()*1000000);

        $cardNumber = isset($CCInfo["CreditCardNumber"]["value"])
            ? $CCInfo["CreditCardNumber"]["value"] : "";
        $CVM = isset($CCInfo["CreditCardVerificationNumber"]["value"])
            ? $CCInfo["CreditCardVerificationNumber"]["value"] : "";

        $cardType = isset($CCInfo["CreditCardType"]["value"])
            ? $CCInfo["CreditCardType"]["value"] : "";

        $cardTypesArray = array(
             "Amex"         => "AM"
            ,"DC"           => "DC"
            ,"Discover"     => "DI"
            ,"FirePay"      => "FP"
            ,"JCB"          => "JC"
            ,"Laser"        => "LA"
            ,"MasterCard"   => "MC"
            ,"Maestro"      => "MD"
            ,"Solo"         => "SO"
            ,"Switch"       => "SW"
            ,"VisaD"        => "VD"
            ,"VisaE"        => "VE"
            ,"Visa"         => "VI"
        );

        if (isset($cardTypesArray[$cardType]))
        {
            $cardType = $cardTypesArray[$cardType];
        }

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? $CCInfo["ExpirationYear"]["value"] % 100 : "";
        $cardExpYear = sprintf("%02d", $cardExpYear);

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $total    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total",                        $currencyId));
        $tax      = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Tax",                          $currencyId));
        $shipping = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost", $currencyId));

        $fields = array(
                     "m_id"  => $settings["MODULE_MERCHANT_ID"]
                    ,"m_key"  => $settings["MODULE_MERCHANT_KEY"]
                    ,"T_code" => "02"
                    ,"C_name" => $billingInfo->getByMask('Firstname').' '.$billingInfo->getByMask('Lastname')
                    ,"C_address"  => $billingInfo->getByMask('Streetline1').' '.$billingInfo->getByMask('Streetline2')
                    ,"C_city"  => $billingInfo->getByMask('City')
                    ,"C_state"  => $bstate
                    ,"C_zip"  => $billingInfo->getByMask('Postcode')
                    ,"C_country"  => $bcountry
                    ,"C_email"  => $billingInfo->getByMask('Email')
                    ,"C_cardnumber" => $cardNumber
                    ,"C_exp"  => $cardExpMonth . $cardExpYear
                    ,"C_cvv" => $CVM
                    ,"T_customer_number"  => $billingInfo->getByMask('Email')
                    ,"T_amt" => $total
                    ,"T_shipping"  => $shipping
                    ,"T_tax"  => $tax
                    ,"T_ordernum"  => $refnum
                    ,"C_telephone" => $billingInfo->getByMask('Phone')
                    ,"C_ship_name"  => $shippingInfo->getByMask('Firstname').' '.$shippingInfo->getByMask('Lastname')
                    ,"C_ship_address" => $shippingInfo->getByMask('Streetline1').' '.$shippingInfo->getByMask('Streetline2')
                    ,"C_ship_city" => $shippingInfo->getByMask('City')
                    ,"C_ship_state" => $sstate
                    ,"C_ship_zip" => $shippingInfo->getByMask('Postcode')
                    ,"C_ship_country" => $scountry
                );

        $content = "";
        foreach ($fields as $key => $value) {
            $content .= $key . '=' . urlencode($value) . '&';
        }

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL("https://www.sagepayments.net/cgi-bin/eftBankcard.dll?transaction");
        $bnc->setPOSTstring($content);
        $result = $bnc->RunRequest();

        if (isset($result["body"]))
        {
            $arrRlt = $this->parseResult($result["body"]);
        }
        else
        {
            $arrRlt["indicator"] = "N"; // no response
        }

        $msgObj = $application->getInstance("MessageResources", "payment-module-sage-messages", "AdminZone");
        if ($arrRlt["indicator"] == "A") // Successful Payment
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => $arrRlt, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // DECLINED or FRAUD
        {
            if ($arrRlt["indicator"] == "N")
            {
                // couldn't reach Sage Gateway,
                // looks like wrong gateway settings
                $msg = $msgObj->getMessage("ERROR_NO_RESPONSE");
                $this->setErrorMessage($msg);
            }
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT")
                    . "Indicator: " . $arrRlt["indicator"]."<br />";
                if ($arrRlt["code"] != '') $msg .= "Error code: " . $arrRlt["code"];
                if ($arrRlt["message"] != '') $msg .= "<br />Message: " . $arrRlt["message"];
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Gets the result string
     * Returns an array with parameters
     */
    function parseResult($res)
    {
        $arrRlt = array();

        $arrRlt["indicator"] = $res[1];

        $arrRlt["code"] = _byte_substr($res, 2, 6);

        $arrRlt["message"] = trim(_byte_substr($res, 8, 32));

        $arrRlt["cvv_indicator"] = $res[42];

        $arrRlt["avs_indicator"] = $res[43];

        $arrRlt["risk_indicator"] = _byte_substr($res, 44, 2);

        $arrRlt["reference"] = _byte_substr($res, 46, 10);

//        echo "Order Number: " . _byte_substr($res, _byte_strpos($res, _byte_chr(28)) + 1,
//            _ml_strrpos($res, _byte_chr(28) - 1)) . "<br>\n";

        return $arrRlt;
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
       return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_sage_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_sage_setting_id'
               ,'key'               => $settings.'.pm_sage_setting_key'
               ,'value'             => $settings.'.pm_sage_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        YourPay                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-sage-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_SAGE_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>