<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package PaymentModuleTranzilaCC
 * @author Egor V. Derevyankin
 *
 */

class update_tranzila extends update_pm_sm
{
    function update_tranzila()
    {}

    function onAction()
    {
        global $application;
        parent::onAction();
        $request = new Request();

        $status = $request->getValueByKey('status');


        $name = $request->getValueByKey('MODULE_NAME');
        $supplier = $request->getValueByKey('SUPPLIER');

        $errors = array();

        if($status == "active")
        {
            //         ,       CheckoutFormEditor'
            //         PersonInfo     : BillingInfo, CreditCardInfo.
            if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "creditCardInfo")) === true)
            {
            }
            else
            {
                $status = "inactive";
                $errors[] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
            }
        }

        if(trim($name) == '')
        {
            $errors[] = 'MODULE_ERROR_NO_NAME';
        };

        if(trim($supplier) == '')
        {
            $errors[] = 'MODULE_ERROR_NO_USERNAME';
        };

        if(empty($errors))
        {
            modApiFunc('Checkout', 'setModuleActive',
                modApiFunc('Payment_Module_Tranzila_CC', 'getUid'),
                ($status == "active"));

            $settings = array(
                'MODULE_NAME' => $name
               ,'SUPPLIER' => $supplier
            );

            modApiFunc('Payment_Module_Tranzila_CC','updateSettings',$settings);
            $SessionPost = array(
                'ViewState' => array(
                    'hasCloseScript' => 'true'
                )
            );
        }
        else
        {
            $SessionPost = array(
                'ViewState' => array(
                    'ErrorsArray' => $errors
                   ,'hasCloseScript' => 'false'
                   ,'FormSubmitValue' => 'save'
                )
            );
        };

        $SessionPost['MODULE_NAME'] = $name;
        $SessionPost['SUPPLIER'] = $supplier;
        $SessionPost['status'] = ($status == 'active');

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
};

?>