<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update VerisignAus settings.
 *
 * @package PaymentModuleVerisignAusCC
 * @access  public
 * @author Egor Makarov
 */
class update_verisign_aus extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * update_verisign_aus constructor.
     */
    function update_verisign_aus()
    {
    }


    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_Verisign_Aus_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array
            (
                "MODULE_NAME"  => $SessionPost["ModuleName"]
                ,"MODULE_MODE" => $SessionPost["ModuleMode"]
                ,"MODULE_LOGIN" => $SessionPost["ModuleLogin"]
                ,"MODULE_PARTNER" => $SessionPost["ModulePartner"]
                ,"MODULE_TYPE" => $SessionPost["ModuleType"]
            );

        modApiFunc("Payment_Module_Verisign_Aus_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;
        $main_currency_id = modApiFunc("Localization", "getMainStoreCurrency");
        $localCurrencyCode = modApiFunc("Localization", "getCurrencyCodeById", $main_currency_id);

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (!array_key_exists('ModuleName', $SessionPost) || trim($SessionPost['ModuleName']) == "")
                {
                    $SessionPost['ViewState']['ErrorsArray'][] = 'MODULE_ERROR_NO_NAME';
                }

                if ($SessionPost["status"] == "active")
                {
                    if (!array_key_exists("ModuleLogin", $SessionPost) || trim($SessionPost['ModuleLogin']) == "")
                    {
                        $SessionPost['ViewState']['ErrorsArray'][] = 'MODULE_ERROR_NO_LOGIN';
                    }
                    if (!array_key_exists('ModulePartner', $SessionPost) || trim($SessionPost['ModulePartner']) == "")
                    {
                        $SessionPost['ViewState']['ErrorsArray'][] = 'MODULE_ERROR_NO_PARTNER';
                    }
                    if ($localCurrencyCode != "AUD")
                    {
                        $SessionPost['ViewState']['ErrorsArray'][] = 'MODULE_ERROR_INVALID_CURRENCY';
                    }
                }
                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>