<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * webpay_cc_input_az view
 *
 * @package PaymentModuleWebpayCC
 * @author Ravil Garafutdinov
 */
class CheckoutPaymentModuleWebpayCCInputAZ extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function CheckoutPaymentModuleWebpayCCInputAZ()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-webpay-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     * Initializes data from the POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST = $SessionPost;
    }

    /**
     * Initializes data from the database.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Payment_Module_Webpay_CC", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":             $this->POST["ModuleName"] = $value; break;
                case "MODULE_CLIENT_ID":        $this->POST["ModuleClientId"] = $value; break;
                case "MODULE_CERTIFICATE_PATH": $this->POST["ModuleCertificatePath"] = $value; break;
                case "MODULE_CERTIFICATE_PASSWORD": $this->POST["ModuleCertificatePassword"] = $value; break;
                case "MODULE_URL":              $this->POST["ModuleUrl"] = $value; break;
                case "MODULE_PORT":             $this->POST["ModulePort"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Payment_Module_Webpay_CC", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }

    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * Outputs errors.
     */
    function outputErrors()
    {
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $error)
        {
            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("payment_module_webpay/", "error.tpl.html", array());
        }
        return $result;
    }

    /**
     * Outputs the module status.
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked" : ""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "" : "checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_webpay/", "status.tpl.html", array());
        return $retval;
    }

    /**
     *
     */
    function outputOrderStatus()
    {
        global $application;
        $retval = "";
        for ($i=1; $i<5; $i++)
        {
            $retval.= "<option value=\"$i\" ";
            $retval.= ($this->POST["ModuleOrderStatusId"] == $i)? "SELECTED " : "";
            $retval.= ">" . $this->MessageResources->getMessage('MODULE_ORDER_STATUS_00'.$i) . "</option>";
        }
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("payment_module_webpay/", "status.tpl.html", array());
        return $retval;
    }


    /**
     * outputs Client Language select options
     *
     * @return "<options>"
     */
    function outputClientLanguageOptions()
    {
        $ret = '';
        $lang = array('nl', 'en', 'de', 'fr', 'es');
        foreach ($lang as $l)
        {
            if ($l == $this->POST["ModuleClientLanguage"])
            {
                $selected = " selected";
            }
            else
            {
                $selected = '';
            }
            $ret .= "<option value='$l'$selected>$l";
        }
        return $ret;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = new Request();
        $request->setView('CheckoutPaymentModuleSettings');
        $request->setAction("update_webpay");
        $form_action = $request->getURL();

        $template_contents = array(
                                    "EditWebpayForm"        => $HtmlForm1->genForm($form_action, "POST", "EditWebpayForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()

                                   ,"ModuleStatusFieldHint" => $this->Hints->getHintLink(array('MODULE_STATUS_FIELD_NAME', 'payment-module-webpay-messages'))
                                   ,"ModuleStatusField"     => $this->outputStatus()

                                   ,"ModuleNameFieldHint"   => $this->Hints->getHintLink(array('MODULE_METHOD_NAME_FIELD_NAME', 'payment-module-webpay-messages'))
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))

                                   ,"ModuleDescrField"      => $HtmlForm1->genInputTextAreaField("75", "ModuleDescr", "5")
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage("MODULE_DESCR")

                                   ,"ModuleClientIdFieldHint"  => $this->Hints->getHintLink(array('MODULE_CLIENT_ID_FIELD_NAME', 'payment-module-webpay-messages'))
                                   ,"ModuleClientIdField"      => $HtmlForm1->genInputTextField("128", "ModuleClientId", "30", prepareHTMLDisplay($this->POST["ModuleClientId"]))

                                   ,"ModuleCertificatePasswordFieldHint"  => $this->Hints->getHintLink(array('MODULE_CERTIFICATE_PASSWORD_FIELD_NAME', 'payment-module-webpay-messages'))
                                   ,"ModuleCertificatePasswordField"      => $HtmlForm1->genInputTextField("128", "ModuleCertificatePassword", "30", prepareHTMLDisplay($this->POST["ModuleCertificatePassword"]))

                                   ,"ModuleUrlFieldHint"  => $this->Hints->getHintLink(array('MODULE_URL_FIELD_NAME', 'payment-module-webpay-messages'))
                                   ,"ModuleUrlField"      => $HtmlForm1->genInputTextField("128", "ModuleUrl", "30", prepareHTMLDisplay($this->POST["ModuleUrl"]))

                                   ,"ModulePortFieldHint"  => $this->Hints->getHintLink(array('MODULE_PORT_FIELD_NAME', 'payment-module-webpay-messages'))
                                   ,"ModulePortField"      => $HtmlForm1->genInputTextField("128", "ModulePort", "30", prepareHTMLDisplay($this->POST["ModulePort"]))

                                   ,"ModuleCertificateFieldHint"  => $this->Hints->getHintLink(array('MODULE_CERTIFICATE_FIELD_NAME', 'payment-module-webpay-messages'))
                                   ,"ModuleCertificateField"      => $HtmlForm1->genInputFileName("ModuleCertificatePath", "70")
                                   ,"ModuleCertificateValue"      => prepareHTMLDisplay(basename($this->POST["ModuleCertificatePath"]))
                                   ,"ModuleCertificateFieldParams"=> ($this->POST["ModuleCertificatePath"] ? "disabled style='display: none;'" : "")
                                   ,"ModuleCertificateChangeParams"=> ($this->POST["ModuleCertificatePath"] ? "" : "style='display: none;'")

                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"             => $this->MessageResources->getMessage('ALERT_004')
                                   ,"Alert_005"             => $this->MessageResources->getMessage('ALERT_005')
                                   ,"Alert_006"             => $this->MessageResources->getMessage('ALERT_006')

                                   ,"PmSmAcceptedCurrencies" => $this->outputAcceptedCurrencies()

                               );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("payment_module_webpay/", "list.tpl.html", array());
    }

    /**
     * Returns the tag output, the name of which was specified in $tag.
     */
    function getTag($tag)
    {
        global $application;
        $value = "";

        if ($tag == "Error")
        {
            $value = $this->_error;
        }
        elseif ($tag == "ErrorIndex")
        {
            $value = $this->_error_index;
        }
        else
        {
            $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        }

        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/

}
?>