<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package ShippingModuleFedEx
 * @access  public
 * @author Egor V. Derevyankin
 */
class update_fedex_settings extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_fedex_settings()
    {
    }

    /**
     * @param $SessionPost array of the posted params
     */
    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Shipping_Module_FedEx", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"     => $SessionPost["ModuleName"]
                         ,"OPTS_CARRIER"    => $SessionPost["FDX_Carrier"]
                         ,"OPTS_SHIP2RES"   => $SessionPost["FDX_Ship2Res"]
                         ,"SRVC_URL"        => $SessionPost["FDX_SrvcURL"]
                         ,"SRVC_ACCOUNT"    => $SessionPost["FDX_SrvcAccount"]
                         ,"SRVC_METER"      => $SessionPost["FDX_SrvcMeter"]
                         ,"SRVC_AUTH_KEY"   => $SessionPost["FDX_SrvcAuthKey"]
                         ,"SRVC_AUTH_PASS"  => $SessionPost["FDX_SrvcAuthPass"]
                         ,"OPTS_DROP_OFF"   => $SessionPost["FDX_DropOff"]
                         ,"OPTS_PACKAGING"  => $SessionPost["FDX_Packaging"]
                         ,"OPTS_MPK_H"      => $SessionPost["FDX_MPKH"]
                         ,"OPTS_MPK_W"      => $SessionPost["FDX_MPKW"]
                         ,"OPTS_MPK_L"      => $SessionPost["FDX_MPKL"]
                         ,"OPTS_MPK_UNITS"  => $SessionPost["FDX_MPKUnits"]
                     );

        modApiFunc("Shipping_Module_FedEx", "updateSettings", $Settings);

        $Methods = array();

        if(isset($SessionPost["SMethodsAvailable"]) and is_array($SessionPost["SMethodsAvailable"]))
            $Methods=$SessionPost["SMethodsAvailable"];

        modApiFunc("Shipping_Module_FedEx", "updateShippingMethods", $Methods);
    }

    /**
     * Action processor.
     */
    function onAction()
    {
        loadCoreFile('URI.class.php');

        global $application;
        $request = $application->getInstance('Request');

        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        $SessionPost["ViewState"]["ErrorsArray"] = array();

        if($SessionPost["status"] == "active")
        {
            //         ,       CheckoutFormEditor'
            //         PersonInfo     : ShippingInfo.
            if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("shippingInfo")) === true)
            {
            }
            else
            {
                $SessionPost["status"]= "inactive";
                $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
            }
        }

        if($SessionPost["ModuleName"]=="")
            $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_001";

        if($SessionPost["status"]=="active")
        {
            if(!isset($SessionPost["SMethodsAvailable"]) or empty($SessionPost["SMethodsAvailable"]))
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_002";

            loadCoreFile('bouncer.php');
            $bnc = new Bouncer();
            if(!$bnc->isSSLavailable())
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_011";

            $SrvcURL = new URI($SessionPost["FDX_SrvcURL"]);
            $SessionPost["FDX_SrvcURL"]=$SrvcURL->getPart("host").$SrvcURL->getPart("path");

            if($SessionPost["FDX_SrvcURL"]=="")
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_003";
            if($SessionPost["FDX_SrvcAccount"]=="")
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_004";
            if($SessionPost["FDX_SrvcMeter"]=="")
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_005";
            if($SessionPost["FDX_SrvcAuthKey"]=="")
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_105";
            if($SessionPost["FDX_SrvcAuthPass"]=="")
                $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_106";

            if($SessionPost["FDX_Packaging"]=="YOURPACKAGING")
            {
                if($SessionPost["FDX_MPKH"]!=""
                    or $SessionPost["FDX_MPKW"]!=""
                    or $SessionPost["FDX_MPKL"]!="")
                {
                    $SessionPost["FDX_MPKH"]=intval(trim($SessionPost["FDX_MPKH"]));
                    $SessionPost["FDX_MPKW"]=intval(trim($SessionPost["FDX_MPKW"]));
                    $SessionPost["FDX_MPKL"]=intval(trim($SessionPost["FDX_MPKL"]));

                    if($SessionPost["FDX_MPKH"]<=0)
                        $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_006";
                    if($SessionPost["FDX_MPKW"]<=0)
                        $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_007";
                    if($SessionPost["FDX_MPKL"]<=0)
                        $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_008";
                }
            }
        }

        if($SessionPost["ViewState"]["FormSubmitValue"]=="Save")
        {
            if(count($SessionPost["ViewState"]["ErrorsArray"])==0
                and count(modApiFunc("Shipping_Module_FedEx","checkRequirments"))==0)
            {
                unset($SessionPost["ViewState"]["ErrorsArray"]);
                $this->saveDataToDB($SessionPost);
                $SessionPost["ViewState"]["hasCloseScript"] = "true";
            };
        };

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>