<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * fedex_input_az view
 *
 * @package ShippingModuleFedEx
 * @author Egor V. Derevyankin
 */
class fedex_input_az extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function fedex_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-fedex-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->shipping_methods=modApiFunc("Shipping_Module_FedEx","getShippingMethods");

        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }

        $requirments=modApiFunc("Shipping_Module_FedEx","checkRequirments");
        $reqsErrors=array("SSL"=>"ERROR_011","OCNTR"=>"ERROR_012","CURRENCY"=>"ERROR_013");
        for($i=0;$i<count($requirments);$i++)
            $this->ErrorsArray[]=$reqsErrors[$requirments[$i]];

        if(count($this->ErrorsArray)>0 and $this->POST["status"]==true)
        {
            $this->POST["status"]=false;
            $this->ViewState["hasCloseScript"]="false";
        };
    }

    /**
     * Copies data from the global POST to the local POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST =
            array(
                "ModuleName"     => $SessionPost["ModuleName"]
               ,"status"         => ($SessionPost["status"]=="active")? true:false
               ,"SrvcURL"        => $SessionPost["FDX_SrvcURL"]
               ,"OptsCarrier"    => $SessionPost["FDX_Carrier"]
               ,"FsrchEXP"       => $SessionPost["FDX_FSE"]
               ,"FsrchGND"       => $SessionPost["FDX_FSG"]
               ,"SrvcAccount"    => $SessionPost["FDX_SrvcAccount"]
               ,"SrvcMeter"      => $SessionPost["FDX_SrvcMeter"]
               ,"SrvcAuthKey"    => $SessionPost["FDX_SrvcAuthKey"]
               ,"SrvcAuthPass"   => $SessionPost["FDX_SrvcAuthPass"]
               ,"OptsDropOff"    => $SessionPost["FDX_DropOff"]
               ,"OptsPackaging"  => $SessionPost["FDX_Packaging"]
               ,"OptsMPKH"       => $SessionPost["FDX_MPKH"]
               ,"OptsMPKW"       => $SessionPost["FDX_MPKW"]
               ,"OptsMPKL"       => $SessionPost["FDX_MPKL"]
               ,"OptsMPKUnits"   => $SessionPost["FDX_MPKUnits"]
               ,"OptsS2R"        => $SessionPost["FDX_Ship2Res"]
               ,"SMethodsAvailable" => array()
            );

        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method['id']] =
                    (isset($SessionPost["SMethodsAvailable"][$method['id']])?"Y":"N");
    }

    /**
     * Fills the local POST array with data from the DB.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Shipping_Module_FedEx", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":     $this->POST["ModuleName"] = $value;     break;
                case "SRVC_URL":        $this->POST["SrvcURL"] = $value;        break;
                case "OPTS_CARRIER":    $this->POST["OptsCarrier"] = $value;    break;
                case "FSRCH_EXP":       $this->POST["FsrchEXP"] = $value;       break;
                case "FSRCH_GND":       $this->POST["FsrchGND"] = $value;       break;
                case "SRVC_ACCOUNT":    $this->POST["SrvcAccount"] = $value;    break;
                case "SRVC_METER":      $this->POST["SrvcMeter"] = $value;      break;
                case "SRVC_AUTH_KEY":   $this->POST["SrvcAuthKey"] = $value;    break;
                case "SRVC_AUTH_PASS":  $this->POST["SrvcAuthPass"] = $value;   break;
                case "OPTS_DROP_OFF":   $this->POST["OptsDropOff"] = $value;    break;
                case "OPTS_PACKAGING":  $this->POST["OptsPackaging"] = $value;  break;
                case "OPTS_MPK_H":      $this->POST["OptsMPKH"] = $value;       break;
                case "OPTS_MPK_W":      $this->POST["OptsMPKW"] = $value;       break;
                case "OPTS_MPK_L":      $this->POST["OptsMPKL"] = $value;       break;
                case "OPTS_MPK_UNITS":  $this->POST["OptsMPKUnits"] = $value;   break;
                case "OPTS_SHIP2RES":   $this->POST["OptsS2R"] = $value;        break;
            }
        }
        $this->POST["status"] = modApiFunc("Shipping_Module_FedEx", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );

        $this->POST["SMethodsAvailable"]=array();
        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method["id"]]=$method["available"];
    }


    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * @return HTML code for the errors
     */
    function outputErrors()
    {
        global $application;

        $return_html_code="";

        foreach($this->ErrorsArray as $index => $value)
        {
            $this->_Template_Contents = array(
                                            "ErrorIndex"    => $index+1,
                                            "Error"         => $this->MessageResources->getMessage($value)
                                        );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "error.tpl.html", array());
        };

        return $return_html_code;
    }

    function outputTopErrors()
    {
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }

        global $application;

        $return_html_code="";

        $this->_Template_Contents = array(
                                            "Errors"    => $this->outputErrors()
                                        );
        $application->registerAttributes($this->_Template_Contents);
        $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "errors.tpl.html", array());

        return $return_html_code;
    }

    /**
     * @return HTML code for the module status
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("shipping_module_fedex/", "status.tpl.html", array());
        return $retval;
    }

    /**
     * @return HTML code for the 'available' checkbox for the shipping method
     */
     function outputAvailableCheckBox($checkbox_id,$available)
    {
        $is_checked=($available=="Y"?"checked":"");
        $return_html_code = "<input type=\"checkbox\" id=\"MA-$checkbox_id\" name=\"SMethodsAvailable[$checkbox_id]\" $is_checked>";
        return $return_html_code;
    }

    /**
     * @return HTML code for the list of the shipping methods
     */
    function outputShippingMethods()
    {
        global $application;

        if(empty($this->shipping_methods) or !is_array($this->shipping_methods))
            return $this->MessageResources->getMessage('LABEL_NO_SHIPPING_METHODS');

        $return_html_code="";

        foreach($this->shipping_methods as $method_key => $method_info)
        {
            $dest=$method_info['destination']=="L"?$this->MessageResources->getMessage("LABEL_SM_DESTINATION_NATIONAL"):
                $this->MessageResources->getMessage("LABEL_SM_DESTINATION_INTERNATIONAL");

            $this->_Template_Contents=array (
                "CycleColor"                    => ( $method_key % 2 ? "EEEEEE":"FFFFFF"),
                "SMethodName"                    => $method_info['method_name'],
                "SMethodDestination"           => $dest,
                "SMethodAvailableCheckBox"     => $this->outputAvailableCheckBox($method_info['id'],$this->POST["SMethodsAvailable"][$method_info['id']])
            );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/","methods_list_item.tpl.html",array());
        }

        return $return_html_code;
    }

    /**
     * @return HTML code for this view
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        # Options data

        # Carrier type
        $opts_carrier_types=array(
                "select_name" => "FDX_Carrier",
                "selected_value" => $this->POST["OptsCarrier"],
                "values" => array(
                        array (
                            "value" => "EXP",
                            "contents" => $this->MessageResources->getMessage('OPTS_CARRIER_EXP'),
                        ),
                        array (
                            "value" => "GND",
                            "contents" => $this->MessageResources->getMessage('OPTS_CARRIER_GND'),
                        ),
                        array (
                            "value" => "BOTH",
                            "contents" => $this->MessageResources->getMessage('OPTS_CARRIER_BOTH'),
                        ),
                    ),
            );

        # Drop-off
        $opts_drop_off=array(
                "select_name" => "FDX_DropOff",
                "selected_value" => $this->POST["OptsDropOff"],
                "values" => array(
                        array (
                            "value" => "REGULAR_PICKUP",
                            "contents" => $this->MessageResources->getMessage('OPTS_DROP_OFF_RP'),
                        ),
                        array (
                            "value" => "REQUEST_COURIER",
                            "contents" => $this->MessageResources->getMessage('OPTS_DROP_OFF_RC'),
                        ),
                        array (
                            "value" => "STATION",
                            "contents" => $this->MessageResources->getMessage('OPTS_DROP_OFF_ST'),
                        ),
                    ),
            );

        # Packaging
        $opts_pack=array(
                "select_name" => "FDX_Packaging",
                "onChange" => "setSizesVisible('EditSMForm')",
                "selected_value" => $this->POST["OptsPackaging"],
                "values" => array(
                        array (
                            "value" => "FEDEX_PAK",
                            "contents" => $this->MessageResources->getMessage('OPTS_PACK_PCK'),
                        ),
                        array (
                            "value" => "FEDEX_BOX",
                            "contents" => $this->MessageResources->getMessage('OPTS_PACK_BOX'),
                        ),
                        array (
                            "value" => "FEDEX_TUBE",
                            "contents" => $this->MessageResources->getMessage('OPTS_PACK_TUB'),
                        ),
                        array (
                            "value" => "FEDEX_ENVELOPE",
                            "contents" => $this->MessageResources->getMessage('OPTS_PACK_ENV'),
                        ),
                        array (
                            "value" => "YOUR_PACKAGING",
                            "contents" => $this->MessageResources->getMessage('OPTS_PACK_MY'),
                        ),
                    ),
            );

        # Dimension units
        $opts_dim_units = array(
                "select_name" => "FDX_MPKUnits",
                "selected_value" => $this->POST["OptsMPKUnits"],
                "values" => array(
                        array (
                            "value" => "IN",
                            "contents" => $this->MessageResources->getMessage('OPTS_MP_IN'),
                        ),
                        array (
                            "value" => "CM",
                            "contents" => $this->MessageResources->getMessage('OPTS_MP_CM'),
                        ),
                    ),
            );

        # Ship to Residence
        $opts_s2r=array(
                "select_name" => "FDX_Ship2Res",
                "selected_value" => $this->POST["OptsS2R"],
                "values" => array(
                        array(
                            "value" => "YES",
                            "contents" => $this->MessageResources->getMessage('OPTS_SHIP2RES_YES'),
                        ),
                        array(
                            "value" => "NO",
                            "contents" => $this->MessageResources->getMessage('OPTS_SHIP2RES_NO'),
                        ),
                    ),
            );

        $request = new Request();
        $request->setView('CheckoutShippingModuleSettings');
        $request->setAction("update_fedex_settings");
        $form_action = $request->getURL();
        $settings = modApiFunc("Shipping_Module_FedEx", "getSettings");

        $template_contents = array(
                 "EditSMForm"                => $HtmlForm1->genForm($form_action, "POST", "EditSMForm")
                ,"HiddenArrayViewState"      => $this->outputViewState()
                ,"ModuleType"                => $this->MessageResources->getMessage('MODULE_TYPE')
                ,"ModuleName"                => $this->MessageResources->getMessage('MODULE_NAME')
                ,"Subtitle"                  => $this->MessageResources->getMessage('FORM_SUBTITLE')
                ,"TopErrors"                 => $this->outputTopErrors()
                ,"ModuleStatusFieldName"     => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                ,"ModuleStatusField"         => $this->outputStatus()
                ,"ModuleNameFieldName"       => $this->MessageResources->getMessage('MODULE_NAME_FIELD_NAME')
                ,"ModuleNameField"           => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))
                ,"ModuleDescrFieldName"      => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                ,"ModuleDescrFieldValue"     => $this->MessageResources->getMessage('MODULE_DESCR')
                ,"OptionsHeader"             => $this->MessageResources->getMessage('OPTS_HEADER')
                ,"OptionsCarrierFieldName"   => $this->MessageResources->getMessage('OPTS_CARRIER')
                ,"OptionsCarrierFieldValue"  => $HtmlForm1->genDropdownSingleChoice($opts_carrier_types)
                ,"FuelSchrsHeader"           => $this->MessageResources->getMessage('FUEL_SCHRS_HEADER')
                ,"FuelSchrsEXPFieldName"     => $this->MessageResources->getMessage('FUEL_EXP_PERC')
                ,"FuelSchrsEXPFieldValue"    => $HtmlForm1->genInputTextField("128","FDX_FSE","75", prepareHTMLDisplay($this->POST["FsrchEXP"]))
                ,"FuelSchrsGNDFieldName"     => $this->MessageResources->getMessage('FUEL_GND_PERC')
                ,"FuelSchrsGNDFieldValue"    => $HtmlForm1->genInputTextField("128","FDX_FSG","75", prepareHTMLDisplay($this->POST["FsrchGND"]))

                ,"FuelSchrsLink"             => $this->MessageResources->getMessage('FUEL_SCHS_LINK')
                ,"FedexboxWarningStyleDisplay" => ($this->POST["OptsPackaging"] == 'FEDEXBOX') ? "" : 'none'

                ,"ServiceURLFieldName"       => $this->MessageResources->getMessage('SERVICE_URL')
                ,"ServiceURLFieldValue"      => $HtmlForm1->genInputTextField("128","FDX_SrvcURL","75", $this->POST["SrvcURL"])
                ,"ServiceAccountFieldName"   => $this->MessageResources->getMessage('SERVICE_ACCOUNT')
                ,"ServiceAccountFieldValue"  => $HtmlForm1->genInputTextField("128","FDX_SrvcAccount","75", $this->POST["SrvcAccount"])
                ,"ServiceMeterFieldName"     => $this->MessageResources->getMessage('SERVICE_METER')
                ,"ServiceMeterFieldValue"    => $HtmlForm1->genInputTextField("128","FDX_SrvcMeter","75", $this->POST["SrvcMeter"])
                ,"ServiceAuthKeyFieldName"   => $this->MessageResources->getMessage('SERVICE_AUTH_KEY')
                ,"ServiceAuthKeyFieldValue"  => $HtmlForm1->genInputTextField("128","FDX_SrvcAuthKey","75", $this->POST["SrvcAuthKey"])
                ,"ServiceAuthPassFieldName"  => $this->MessageResources->getMessage('SERVICE_AUTH_PASS')
                ,"ServiceAuthPassFieldValue" => $HtmlForm1->genInputTextField("128","FDX_SrvcAuthPass","75", $this->POST["SrvcAuthPass"])
                ,"OptionsDropOffFieldName"   => $this->MessageResources->getMessage('OPTS_DROP_OFF')
                ,"OptionsDropOffFieldValue"  => $HtmlForm1->genDropdownSingleChoice($opts_drop_off)
                ,"OptionsPackFieldName"      => $this->MessageResources->getMessage('OPTS_PACK')
                ,"OptionsPackFieldValue"     => $HtmlForm1->genDropdownSingleChoice($opts_pack)
                ,"OptionsMPKHFieldName"      => $this->MessageResources->getMessage('OPTS_MP_HEIGHT')
                ,"OptionsMPKHFieldValue"     => $HtmlForm1->genInputTextField("128","FDX_MPKH", "75", $this->POST["OptsMPKH"])
                ,"OptionsMPKWFieldName"      => $this->MessageResources->getMessage('OPTS_MP_WIDTH')
                ,"OptionsMPKWFieldValue"     => $HtmlForm1->genInputTextField("128","FDX_MPKW", "75", $this->POST["OptsMPKW"])
                ,"OptionsMPKLFieldName"      => $this->MessageResources->getMessage('OPTS_MP_LENGTH')
                ,"OptionsMPKLFieldValue"     => $HtmlForm1->genInputTextField("128","FDX_MPKL", "75", $this->POST["OptsMPKL"])
                ,"OptionsMPKUFieldName"      => $this->MessageResources->getMessage('OPTS_MP_UNITS')
                ,"OptionsMPKUFieldValue"     => $HtmlForm1->genDropdownSingleChoice($opts_dim_units)
                ,"OptionsShip2ResFieldName"  => $this->MessageResources->getMessage('OPTS_SHIP2RES')
                ,"OptionsShip2ResFieldValue" => $HtmlForm1->genDropdownSingleChoice($opts_s2r)
                ,"MethodsHeader"             => $this->MessageResources->getMessage('METHODS_HEADER')
                ,"MethodsList"               => $this->outputShippingMethods()
                ,"LabelSMName"               => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_NAME')
                ,"LabelSMDestination"        => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_DESTINATION')
                ,"LabelSMAvailable"          => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_AVAILABLE')
                ,"MethodsCount"              => count($this->shipping_methods)
                ,"Alert_001"                 => $this->MessageResources->getMessage('ALERT_001')
                ,"Alert_002"                 => $this->MessageResources->getMessage('ALERT_002')
                ,"Alert_003"                 => $this->MessageResources->getMessage('ALERT_003')
                ,"Alert_004"                 => $this->MessageResources->getMessage('ALERT_004')
                ,"Alert_005"                 => $this->MessageResources->getMessage('ALERT_005')
                ,"Alert_006"                 => $this->MessageResources->getMessage('ALERT_006')
                ,"Alert_009"                 => $this->MessageResources->getMessage('ALERT_009')
                ,"Alert_010"                 => $this->MessageResources->getMessage('ALERT_010')
                ,"Alert_105"                 => $this->MessageResources->getMessage('ALERT_105')
                ,"Alert_106"                 => $this->MessageResources->getMessage('ALERT_106')
                ,"HintLink_CT"               => $this->Hints->getHintLink(array('OPTS_CARRIER','shipping-module-fedex-messages'))
                ,"HintLink_CM"               => $this->Hints->getHintLink(array('CALC_METHOD','shipping-module-fedex-messages'))
                ,"HintLink_FS"               => $this->Hints->getHintLink(array('FUEL_SCHRS_HEADER','shipping-module-fedex-messages'))
                ,"HintLink_SURL"             => $this->Hints->getHintLink(array('SERVICE_URL','shipping-module-fedex-messages'))
                ,"HintLink_SACC"             => $this->Hints->getHintLink(array('SERVICE_ACCOUNT','shipping-module-fedex-messages'))
                ,"HintLink_SMN"              => $this->Hints->getHintLink(array('SERVICE_METER','shipping-module-fedex-messages'))
                ,"HintLink_SAK"              => $this->Hints->getHintLink(array('SERVICE_AUTH_KEY','shipping-module-fedex-messages'))
                ,"HintLink_SAP"              => $this->Hints->getHintLink(array('SERVICE_AUTH_PASS','shipping-module-fedex-messages'))
                ,"HintLink_DOT"              => $this->Hints->getHintLink(array('OPTS_DROP_OFF','shipping-module-fedex-messages'))
                ,"HintLink_PCK"              => $this->Hints->getHintLink(array('OPTS_PACK','shipping-module-fedex-messages'))
                ,"HintLink_MPKH"             => $this->Hints->getHintLink(array('OPTS_MP_HEIGHT','shipping-module-fedex-messages'))
                ,"HintLink_MPKW"             => $this->Hints->getHintLink(array('OPTS_MP_WIDTH','shipping-module-fedex-messages'))
                ,"HintLink_MPKL"             => $this->Hints->getHintLink(array('OPTS_MP_LENGTH','shipping-module-fedex-messages'))
                ,"HintLink_MPKU"             => $this->Hints->getHintLink(array('OPTS_MP_UNITS','shipping-module-fedex-messages'))
        );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("shipping_module_fedex/", "list.tpl.html",array());
    }

    /**
     * @param $tag name of the requested tag
     * @return value of the tag
     */
    function getTag($tag)
    {
        return getKeyIgnoreCase($tag, $this->_Template_Contents);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    var $shipping_methods;

    /**#@-*/
}
?>